var rs = Object.defineProperty;
var is = (o, t, e) => t in o ? rs(o, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : o[t] = e;
var mt = (o, t, e) => (is(o, typeof t != "symbol" ? t + "" : t, e), e);
import { ViewPlugin as Dt, EditorView as nt, Decoration as G, WidgetType as ns, Direction as kt, logException as os } from "@codemirror/view";
import { StateField as Ae, RangeSetBuilder as le, Facet as _t, EditorState as At, StateEffect as $s, Prec as je } from "@codemirror/state";
const Ce = 1024;
let ls = 0;
class jt {
  constructor(t, e) {
    this.from = t, this.to = e;
  }
}
class b {
  /**
  Create a new node prop type.
  */
  constructor(t = {}) {
    this.id = ls++, this.perNode = !!t.perNode, this.deserialize = t.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(t) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof t != "function" && (t = R.match(t)), (e) => {
      let s = t(e);
      return s === void 0 ? null : [this, s];
    };
  }
}
b.closedBy = new b({ deserialize: (o) => o.split(" ") });
b.openedBy = new b({ deserialize: (o) => o.split(" ") });
b.group = new b({ deserialize: (o) => o.split(" ") });
b.isolate = new b({ deserialize: (o) => {
  if (o && o != "rtl" && o != "ltr" && o != "auto")
    throw new RangeError("Invalid value for isolate: " + o);
  return o || "auto";
} });
b.contextHash = new b({ perNode: !0 });
b.lookAhead = new b({ perNode: !0 });
b.mounted = new b({ perNode: !0 });
class Ft {
  constructor(t, e, s) {
    this.tree = t, this.overlay = e, this.parser = s;
  }
  /**
  @internal
  */
  static get(t) {
    return t && t.props && t.props[b.mounted.id];
  }
}
const hs = /* @__PURE__ */ Object.create(null);
class R {
  /**
  @internal
  */
  constructor(t, e, s, r = 0) {
    this.name = t, this.props = e, this.id = s, this.flags = r;
  }
  /**
  Define a node type.
  */
  static define(t) {
    let e = t.props && t.props.length ? /* @__PURE__ */ Object.create(null) : hs, s = (t.top ? 1 : 0) | (t.skipped ? 2 : 0) | (t.error ? 4 : 0) | (t.name == null ? 8 : 0), r = new R(t.name || "", e, t.id, s);
    if (t.props) {
      for (let i of t.props)
        if (Array.isArray(i) || (i = i(r)), i) {
          if (i[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          e[i[0].id] = i[1];
        }
    }
    return r;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(t) {
    return this.props[t.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(t) {
    if (typeof t == "string") {
      if (this.name == t)
        return !0;
      let e = this.prop(b.group);
      return e ? e.indexOf(t) > -1 : !1;
    }
    return this.id == t;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(t) {
    let e = /* @__PURE__ */ Object.create(null);
    for (let s in t)
      for (let r of s.split(" "))
        e[r] = t[s];
    return (s) => {
      for (let r = s.prop(b.group), i = -1; i < (r ? r.length : 0); i++) {
        let n = e[i < 0 ? s.name : r[i]];
        if (n)
          return n;
      }
    };
  }
}
R.none = new R(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class he {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(t) {
    this.types = t;
    for (let e = 0; e < t.length; e++)
      if (t[e].id != e)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...t) {
    let e = [];
    for (let s of this.types) {
      let r = null;
      for (let i of t) {
        let n = i(s);
        n && (r || (r = Object.assign({}, s.props)), r[n[0].id] = n[1]);
      }
      e.push(r ? new R(s.name, r, s.id, s.flags) : s);
    }
    return new he(e);
  }
}
const xt = /* @__PURE__ */ new WeakMap(), We = /* @__PURE__ */ new WeakMap();
var T;
(function(o) {
  o[o.ExcludeBuffers = 1] = "ExcludeBuffers", o[o.IncludeAnonymous = 2] = "IncludeAnonymous", o[o.IgnoreMounts = 4] = "IgnoreMounts", o[o.IgnoreOverlays = 8] = "IgnoreOverlays";
})(T || (T = {}));
class k {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(t, e, s, r, i) {
    if (this.type = t, this.children = e, this.positions = s, this.length = r, this.props = null, i && i.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [n, $] of i)
        this.props[typeof n == "number" ? n : n.id] = $;
    }
  }
  /**
  @internal
  */
  toString() {
    let t = Ft.get(this);
    if (t && !t.overlay)
      return t.tree.toString();
    let e = "";
    for (let s of this.children) {
      let r = s.toString();
      r && (e && (e += ","), e += r);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (e.length ? "(" + e + ")" : "") : e;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(t = 0) {
    return new se(this.topNode, t);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(t, e = 0, s = 0) {
    let r = xt.get(this) || this.topNode, i = new se(r);
    return i.moveTo(t, e), xt.set(this, i._tree), i;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new D(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(t, e = 0) {
    let s = Ot(xt.get(this) || this.topNode, t, e, !1);
    return xt.set(this, s), s;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(t, e = 0) {
    let s = Ot(We.get(this) || this.topNode, t, e, !0);
    return We.set(this, s), s;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(t, e = 0) {
    return us(this, t, e);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(t) {
    let { enter: e, leave: s, from: r = 0, to: i = this.length } = t, n = t.mode || 0, $ = (n & T.IncludeAnonymous) > 0;
    for (let l = this.cursor(n | T.IncludeAnonymous); ; ) {
      let h = !1;
      if (l.from <= i && l.to >= r && (!$ && l.type.isAnonymous || e(l) !== !1)) {
        if (l.firstChild())
          continue;
        h = !0;
      }
      for (; h && s && ($ || !l.type.isAnonymous) && s(l), !l.nextSibling(); ) {
        if (!l.parent())
          return;
        h = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(t) {
    return t.perNode ? this.props ? this.props[t.id] : void 0 : this.type.prop(t);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let t = [];
    if (this.props)
      for (let e in this.props)
        t.push([+e, this.props[e]]);
    return t;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(t = {}) {
    return this.children.length <= 8 ? this : ue(R.none, this.children, this.positions, 0, this.children.length, 0, this.length, (e, s, r) => new k(this.type, e, s, r, this.propValues), t.makeTree || ((e, s, r) => new k(R.none, e, s, r)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(t) {
    return fs(t);
  }
}
k.empty = new k(R.none, [], [], 0);
class ae {
  constructor(t, e) {
    this.buffer = t, this.index = e;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new ae(this.buffer, this.index);
  }
}
class tt {
  /**
  Create a tree buffer.
  */
  constructor(t, e, s) {
    this.buffer = t, this.length = e, this.set = s;
  }
  /**
  @internal
  */
  get type() {
    return R.none;
  }
  /**
  @internal
  */
  toString() {
    let t = [];
    for (let e = 0; e < this.buffer.length; )
      t.push(this.childString(e)), e = this.buffer[e + 3];
    return t.join(",");
  }
  /**
  @internal
  */
  childString(t) {
    let e = this.buffer[t], s = this.buffer[t + 3], r = this.set.types[e], i = r.name;
    if (/\W/.test(i) && !r.isError && (i = JSON.stringify(i)), t += 4, s == t)
      return i;
    let n = [];
    for (; t < s; )
      n.push(this.childString(t)), t = this.buffer[t + 3];
    return i + "(" + n.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(t, e, s, r, i) {
    let { buffer: n } = this, $ = -1;
    for (let l = t; l != e && !(Xe(i, r, n[l + 1], n[l + 2]) && ($ = l, s > 0)); l = n[l + 3])
      ;
    return $;
  }
  /**
  @internal
  */
  slice(t, e, s) {
    let r = this.buffer, i = new Uint16Array(e - t), n = 0;
    for (let $ = t, l = 0; $ < e; ) {
      i[l++] = r[$++], i[l++] = r[$++] - s;
      let h = i[l++] = r[$++] - s;
      i[l++] = r[$++] - t, n = Math.max(n, h);
    }
    return new tt(i, n, this.set);
  }
}
function Xe(o, t, e, s) {
  switch (o) {
    case -2:
      return e < t;
    case -1:
      return s >= t && e < t;
    case 0:
      return e < t && s > t;
    case 1:
      return e <= t && s > t;
    case 2:
      return s > t;
    case 4:
      return !0;
  }
}
function Ot(o, t, e, s) {
  for (var r; o.from == o.to || (e < 1 ? o.from >= t : o.from > t) || (e > -1 ? o.to <= t : o.to < t); ) {
    let n = !s && o instanceof D && o.index < 0 ? null : o.parent;
    if (!n)
      return o;
    o = n;
  }
  let i = s ? 0 : T.IgnoreOverlays;
  if (s)
    for (let n = o, $ = n.parent; $; n = $, $ = n.parent)
      n instanceof D && n.index < 0 && ((r = $.enter(t, e, i)) === null || r === void 0 ? void 0 : r.from) != n.from && (o = $);
  for (; ; ) {
    let n = o.enter(t, e, i);
    if (!n)
      return o;
    o = n;
  }
}
class Ge {
  cursor(t = 0) {
    return new se(this, t);
  }
  getChild(t, e = null, s = null) {
    let r = Oe(this, t, e, s);
    return r.length ? r[0] : null;
  }
  getChildren(t, e = null, s = null) {
    return Oe(this, t, e, s);
  }
  resolve(t, e = 0) {
    return Ot(this, t, e, !1);
  }
  resolveInner(t, e = 0) {
    return Ot(this, t, e, !0);
  }
  matchContext(t) {
    return ee(this, t);
  }
  enterUnfinishedNodesBefore(t) {
    let e = this.childBefore(t), s = this;
    for (; e; ) {
      let r = e.lastChild;
      if (!r || r.to != e.to)
        break;
      r.type.isError && r.from == r.to ? (s = e, e = r.prevSibling) : e = r;
    }
    return s;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class D extends Ge {
  constructor(t, e, s, r) {
    super(), this._tree = t, this.from = e, this.index = s, this._parent = r;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(t, e, s, r, i = 0) {
    for (let n = this; ; ) {
      for (let { children: $, positions: l } = n._tree, h = e > 0 ? $.length : -1; t != h; t += e) {
        let c = $[t], a = l[t] + n.from;
        if (Xe(r, s, a, a + c.length)) {
          if (c instanceof tt) {
            if (i & T.ExcludeBuffers)
              continue;
            let f = c.findChild(0, c.buffer.length, e, s - a, r);
            if (f > -1)
              return new H(new as(n, c, t, a), null, f);
          } else if (i & T.IncludeAnonymous || !c.type.isAnonymous || ce(c)) {
            let f;
            if (!(i & T.IgnoreMounts) && (f = Ft.get(c)) && !f.overlay)
              return new D(f.tree, a, t, n);
            let p = new D(c, a, t, n);
            return i & T.IncludeAnonymous || !p.type.isAnonymous ? p : p.nextChild(e < 0 ? c.children.length - 1 : 0, e, s, r);
          }
        }
      }
      if (i & T.IncludeAnonymous || !n.type.isAnonymous || (n.index >= 0 ? t = n.index + e : t = e < 0 ? -1 : n._parent._tree.children.length, n = n._parent, !n))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(t) {
    return this.nextChild(
      0,
      1,
      t,
      2
      /* Side.After */
    );
  }
  childBefore(t) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  enter(t, e, s = 0) {
    let r;
    if (!(s & T.IgnoreOverlays) && (r = Ft.get(this._tree)) && r.overlay) {
      let i = t - this.from;
      for (let { from: n, to: $ } of r.overlay)
        if ((e > 0 ? n <= i : n < i) && (e < 0 ? $ >= i : $ > i))
          return new D(r.tree, r.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, t, e, s);
  }
  nextSignificantParent() {
    let t = this;
    for (; t.type.isAnonymous && t._parent; )
      t = t._parent;
    return t;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function Oe(o, t, e, s) {
  let r = o.cursor(), i = [];
  if (!r.firstChild())
    return i;
  if (e != null) {
    for (; !r.type.is(e); )
      if (!r.nextSibling())
        return i;
  }
  for (; ; ) {
    if (s != null && r.type.is(s))
      return i;
    if (r.type.is(t) && i.push(r.node), !r.nextSibling())
      return s == null ? i : [];
  }
}
function ee(o, t, e = t.length - 1) {
  for (let s = o.parent; e >= 0; s = s.parent) {
    if (!s)
      return !1;
    if (!s.type.isAnonymous) {
      if (t[e] && t[e] != s.name)
        return !1;
      e--;
    }
  }
  return !0;
}
class as {
  constructor(t, e, s, r) {
    this.parent = t, this.buffer = e, this.index = s, this.start = r;
  }
}
class H extends Ge {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(t, e, s) {
    super(), this.context = t, this._parent = e, this.index = s, this.type = t.buffer.set.types[t.buffer.buffer[s]];
  }
  child(t, e, s) {
    let { buffer: r } = this.context, i = r.findChild(this.index + 4, r.buffer[this.index + 3], t, e - this.context.start, s);
    return i < 0 ? null : new H(this.context, this, i);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(t) {
    return this.child(
      1,
      t,
      2
      /* Side.After */
    );
  }
  childBefore(t) {
    return this.child(
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  enter(t, e, s = 0) {
    if (s & T.ExcludeBuffers)
      return null;
    let { buffer: r } = this.context, i = r.findChild(this.index + 4, r.buffer[this.index + 3], e > 0 ? 1 : -1, t - this.context.start, e);
    return i < 0 ? null : new H(this.context, this, i);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(t) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + t,
      t,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: t } = this.context, e = t.buffer[this.index + 3];
    return e < (this._parent ? t.buffer[this._parent.index + 3] : t.buffer.length) ? new H(this.context, this._parent, e) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: t } = this.context, e = this._parent ? this._parent.index + 4 : 0;
    return this.index == e ? this.externalSibling(-1) : new H(this.context, this._parent, t.findChild(
      e,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let t = [], e = [], { buffer: s } = this.context, r = this.index + 4, i = s.buffer[this.index + 3];
    if (i > r) {
      let n = s.buffer[this.index + 1];
      t.push(s.slice(r, i, n)), e.push(0);
    }
    return new k(this.type, t, e, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function Ne(o) {
  if (!o.length)
    return null;
  let t = 0, e = o[0];
  for (let i = 1; i < o.length; i++) {
    let n = o[i];
    (n.from > e.from || n.to < e.to) && (e = n, t = i);
  }
  let s = e instanceof D && e.index < 0 ? null : e.parent, r = o.slice();
  return s ? r[t] = s : r.splice(t, 1), new cs(r, e);
}
class cs {
  constructor(t, e) {
    this.heads = t, this.node = e;
  }
  get next() {
    return Ne(this.heads);
  }
}
function us(o, t, e) {
  let s = o.resolveInner(t, e), r = null;
  for (let i = s instanceof D ? s : s.context.parent; i; i = i.parent)
    if (i.index < 0) {
      let n = i.parent;
      (r || (r = [s])).push(n.resolve(t, e)), i = n;
    } else {
      let n = Ft.get(i.tree);
      if (n && n.overlay && n.overlay[0].from <= t && n.overlay[n.overlay.length - 1].to >= t) {
        let $ = new D(n.tree, n.overlay[0].from + i.from, -1, i);
        (r || (r = [s])).push(Ot($, t, e, !1));
      }
    }
  return r ? Ne(r) : s;
}
class se {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(t, e = 0) {
    if (this.mode = e, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t instanceof D)
      this.yieldNode(t);
    else {
      this._tree = t.context.parent, this.buffer = t.context;
      for (let s = t._parent; s; s = s._parent)
        this.stack.unshift(s.index);
      this.bufferNode = t, this.yieldBuf(t.index);
    }
  }
  yieldNode(t) {
    return t ? (this._tree = t, this.type = t.type, this.from = t.from, this.to = t.to, !0) : !1;
  }
  yieldBuf(t, e) {
    this.index = t;
    let { start: s, buffer: r } = this.buffer;
    return this.type = e || r.set.types[r.buffer[t]], this.from = s + r.buffer[t + 1], this.to = s + r.buffer[t + 2], !0;
  }
  /**
  @internal
  */
  yield(t) {
    return t ? t instanceof D ? (this.buffer = null, this.yieldNode(t)) : (this.buffer = t.context, this.yieldBuf(t.index, t.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(t, e, s) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(t < 0 ? this._tree._tree.children.length - 1 : 0, t, e, s, this.mode));
    let { buffer: r } = this.buffer, i = r.findChild(this.index + 4, r.buffer[this.index + 3], t, e - this.buffer.start, s);
    return i < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(i));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(t) {
    return this.enterChild(
      1,
      t,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(t) {
    return this.enterChild(
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(t, e, s = this.mode) {
    return this.buffer ? s & T.ExcludeBuffers ? !1 : this.enterChild(1, t, e) : this.yield(this._tree.enter(t, e, s));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & T.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let t = this.mode & T.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(t);
  }
  /**
  @internal
  */
  sibling(t) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + t, t, 0, 4, this.mode)) : !1;
    let { buffer: e } = this.buffer, s = this.stack.length - 1;
    if (t < 0) {
      let r = s < 0 ? 0 : this.stack[s] + 4;
      if (this.index != r)
        return this.yieldBuf(e.findChild(
          r,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let r = e.buffer[this.index + 3];
      if (r < (s < 0 ? e.buffer.length : e.buffer[this.stack[s] + 3]))
        return this.yieldBuf(r);
    }
    return s < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + t, t, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(t) {
    let e, s, { buffer: r } = this;
    if (r) {
      if (t > 0) {
        if (this.index < r.buffer.buffer.length)
          return !1;
      } else
        for (let i = 0; i < this.index; i++)
          if (r.buffer.buffer[i + 3] < this.index)
            return !1;
      ({ index: e, parent: s } = r);
    } else
      ({ index: e, _parent: s } = this._tree);
    for (; s; { index: e, _parent: s } = s)
      if (e > -1)
        for (let i = e + t, n = t < 0 ? -1 : s._tree.children.length; i != n; i += t) {
          let $ = s._tree.children[i];
          if (this.mode & T.IncludeAnonymous || $ instanceof tt || !$.type.isAnonymous || ce($))
            return !1;
        }
    return !0;
  }
  move(t, e) {
    if (e && this.enterChild(
      t,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(t))
        return !0;
      if (this.atLastNode(t) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(t = !0) {
    return this.move(1, t);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(t = !0) {
    return this.move(-1, t);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(t, e = 0) {
    for (; (this.from == this.to || (e < 1 ? this.from >= t : this.from > t) || (e > -1 ? this.to <= t : this.to < t)) && this.parent(); )
      ;
    for (; this.enterChild(1, t, e); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let t = this.bufferNode, e = null, s = 0;
    if (t && t.context == this.buffer)
      t:
        for (let r = this.index, i = this.stack.length; i >= 0; ) {
          for (let n = t; n; n = n._parent)
            if (n.index == r) {
              if (r == this.index)
                return n;
              e = n, s = i + 1;
              break t;
            }
          r = this.stack[--i];
        }
    for (let r = s; r < this.stack.length; r++)
      e = new H(this.buffer, e, this.stack[r]);
    return this.bufferNode = new H(this.buffer, e, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(t, e) {
    for (let s = 0; ; ) {
      let r = !1;
      if (this.type.isAnonymous || t(this) !== !1) {
        if (this.firstChild()) {
          s++;
          continue;
        }
        this.type.isAnonymous || (r = !0);
      }
      for (; r && e && e(this), r = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!s)
          return;
        this.parent(), s--, r = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(t) {
    if (!this.buffer)
      return ee(this.node, t);
    let { buffer: e } = this.buffer, { types: s } = e.set;
    for (let r = t.length - 1, i = this.stack.length - 1; r >= 0; i--) {
      if (i < 0)
        return ee(this.node, t, r);
      let n = s[e.buffer[this.stack[i]]];
      if (!n.isAnonymous) {
        if (t[r] && t[r] != n.name)
          return !1;
        r--;
      }
    }
    return !0;
  }
}
function ce(o) {
  return o.children.some((t) => t instanceof tt || !t.type.isAnonymous || ce(t));
}
function fs(o) {
  var t;
  let { buffer: e, nodeSet: s, maxBufferLength: r = Ce, reused: i = [], minRepeatType: n = s.types.length } = o, $ = Array.isArray(e) ? new ae(e, e.length) : e, l = s.types, h = 0, c = 0;
  function a(x, P, W, J, I, S) {
    let { id: O, start: g, end: y, size: w } = $, q = c;
    for (; w < 0; )
      if ($.next(), w == -1) {
        let N = i[O];
        W.push(N), J.push(g - x);
        return;
      } else if (w == -3) {
        h = O;
        return;
      } else if (w == -4) {
        c = O;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${w}`);
    let et = l[O], $t, st, de = g - x;
    if (y - g <= r && (st = F($.pos - P, I))) {
      let N = new Uint16Array(st.size - st.skip), U = $.pos - st.size, K = N.length;
      for (; $.pos > U; )
        K = B(st.start, N, K);
      $t = new tt(N, y - st.start, s), de = st.start - x;
    } else {
      let N = $.pos - w;
      $.next();
      let U = [], K = [], rt = O >= n ? O : -1, lt = 0, gt = y;
      for (; $.pos > N; )
        rt >= 0 && $.id == rt && $.size >= 0 ? ($.end <= gt - r && (V(U, K, g, lt, $.end, gt, rt, q), lt = U.length, gt = $.end), $.next()) : S > 2500 ? f(g, N, U, K) : a(g, N, U, K, rt, S + 1);
      if (rt >= 0 && lt > 0 && lt < U.length && V(U, K, g, lt, g, gt, rt, q), U.reverse(), K.reverse(), rt > -1 && lt > 0) {
        let Ve = p(et);
        $t = ue(et, U, K, 0, U.length, 0, y - g, Ve, Ve);
      } else
        $t = m(et, U, K, y - g, q - y);
    }
    W.push($t), J.push(de);
  }
  function f(x, P, W, J) {
    let I = [], S = 0, O = -1;
    for (; $.pos > P; ) {
      let { id: g, start: y, end: w, size: q } = $;
      if (q > 4)
        $.next();
      else {
        if (O > -1 && y < O)
          break;
        O < 0 && (O = w - r), I.push(g, y, w), S++, $.next();
      }
    }
    if (S) {
      let g = new Uint16Array(S * 4), y = I[I.length - 2];
      for (let w = I.length - 3, q = 0; w >= 0; w -= 3)
        g[q++] = I[w], g[q++] = I[w + 1] - y, g[q++] = I[w + 2] - y, g[q++] = q;
      W.push(new tt(g, I[2] - y, s)), J.push(y - x);
    }
  }
  function p(x) {
    return (P, W, J) => {
      let I = 0, S = P.length - 1, O, g;
      if (S >= 0 && (O = P[S]) instanceof k) {
        if (!S && O.type == x && O.length == J)
          return O;
        (g = O.prop(b.lookAhead)) && (I = W[S] + O.length + g);
      }
      return m(x, P, W, J, I);
    };
  }
  function V(x, P, W, J, I, S, O, g) {
    let y = [], w = [];
    for (; x.length > J; )
      y.push(x.pop()), w.push(P.pop() + W - I);
    x.push(m(s.types[O], y, w, S - I, g - S)), P.push(I - W);
  }
  function m(x, P, W, J, I = 0, S) {
    if (h) {
      let O = [b.contextHash, h];
      S = S ? [O].concat(S) : [O];
    }
    if (I > 25) {
      let O = [b.lookAhead, I];
      S = S ? [O].concat(S) : [O];
    }
    return new k(x, P, W, J, S);
  }
  function F(x, P) {
    let W = $.fork(), J = 0, I = 0, S = 0, O = W.end - r, g = { size: 0, start: 0, skip: 0 };
    t:
      for (let y = W.pos - x; W.pos > y; ) {
        let w = W.size;
        if (W.id == P && w >= 0) {
          g.size = J, g.start = I, g.skip = S, S += 4, J += 4, W.next();
          continue;
        }
        let q = W.pos - w;
        if (w < 0 || q < y || W.start < O)
          break;
        let et = W.id >= n ? 4 : 0, $t = W.start;
        for (W.next(); W.pos > q; ) {
          if (W.size < 0)
            if (W.size == -3)
              et += 4;
            else
              break t;
          else
            W.id >= n && (et += 4);
          W.next();
        }
        I = $t, J += w, S += et;
      }
    return (P < 0 || J == x) && (g.size = J, g.start = I, g.skip = S), g.size > 4 ? g : void 0;
  }
  function B(x, P, W) {
    let { id: J, start: I, end: S, size: O } = $;
    if ($.next(), O >= 0 && J < n) {
      let g = W;
      if (O > 4) {
        let y = $.pos - (O - 4);
        for (; $.pos > y; )
          W = B(x, P, W);
      }
      P[--W] = g, P[--W] = S - x, P[--W] = I - x, P[--W] = J;
    } else
      O == -3 ? h = J : O == -4 && (c = J);
    return W;
  }
  let z = [], E = [];
  for (; $.pos > 0; )
    a(o.start || 0, o.bufferStart || 0, z, E, -1, 0);
  let Y = (t = o.length) !== null && t !== void 0 ? t : z.length ? E[0] + z[0].length : 0;
  return new k(l[o.topID], z.reverse(), E.reverse(), Y);
}
const ge = /* @__PURE__ */ new WeakMap();
function Jt(o, t) {
  if (!o.isAnonymous || t instanceof tt || t.type != o)
    return 1;
  let e = ge.get(t);
  if (e == null) {
    e = 1;
    for (let s of t.children) {
      if (s.type != o || !(s instanceof k)) {
        e = 1;
        break;
      }
      e += Jt(o, s);
    }
    ge.set(t, e);
  }
  return e;
}
function ue(o, t, e, s, r, i, n, $, l) {
  let h = 0;
  for (let V = s; V < r; V++)
    h += Jt(o, t[V]);
  let c = Math.ceil(
    h * 1.5 / 8
    /* Balance.BranchFactor */
  ), a = [], f = [];
  function p(V, m, F, B, z) {
    for (let E = F; E < B; ) {
      let Y = E, x = m[E], P = Jt(o, V[E]);
      for (E++; E < B; E++) {
        let W = Jt(o, V[E]);
        if (P + W >= c)
          break;
        P += W;
      }
      if (E == Y + 1) {
        if (P > c) {
          let W = V[Y];
          p(W.children, W.positions, 0, W.children.length, m[Y] + z);
          continue;
        }
        a.push(V[Y]);
      } else {
        let W = m[E - 1] + V[E - 1].length - x;
        a.push(ue(o, V, m, Y, E, x, W, null, l));
      }
      f.push(x + z - i);
    }
  }
  return p(t, e, s, r, 0), ($ || l)(a, f, n);
}
class ot {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(t, e, s, r, i = !1, n = !1) {
    this.from = t, this.to = e, this.tree = s, this.offset = r, this.open = (i ? 1 : 0) | (n ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(t, e = [], s = !1) {
    let r = [new ot(0, t.length, t, 0, !1, s)];
    for (let i of e)
      i.to > t.length && r.push(i);
    return r;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(t, e, s = 128) {
    if (!e.length)
      return t;
    let r = [], i = 1, n = t.length ? t[0] : null;
    for (let $ = 0, l = 0, h = 0; ; $++) {
      let c = $ < e.length ? e[$] : null, a = c ? c.fromA : 1e9;
      if (a - l >= s)
        for (; n && n.from < a; ) {
          let f = n;
          if (l >= f.from || a <= f.to || h) {
            let p = Math.max(f.from, l) - h, V = Math.min(f.to, a) - h;
            f = p >= V ? null : new ot(p, V, f.tree, f.offset + h, $ > 0, !!c);
          }
          if (f && r.push(f), n.to > a)
            break;
          n = i < t.length ? t[i++] : null;
        }
      if (!c)
        break;
      l = c.toA, h = c.toA - c.toB;
    }
    return r;
  }
}
class Qe {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(t, e, s) {
    return typeof t == "string" && (t = new ps(t)), s = s ? s.length ? s.map((r) => new jt(r.from, r.to)) : [new jt(0, 0)] : [new jt(0, t.length)], this.createParse(t, e || [], s);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(t, e, s) {
    let r = this.startParse(t, e, s);
    for (; ; ) {
      let i = r.advance();
      if (i)
        return i;
    }
  }
}
class ps {
  constructor(t) {
    this.string = t;
  }
  get length() {
    return this.string.length;
  }
  chunk(t) {
    return this.string.slice(t);
  }
  get lineChunks() {
    return !1;
  }
  read(t, e) {
    return this.string.slice(t, e);
  }
}
new b({ perNode: !0 });
class Tt {
  /**
  @internal
  */
  constructor(t, e, s, r, i, n, $, l, h, c = 0, a) {
    this.p = t, this.stack = e, this.state = s, this.reducePos = r, this.pos = i, this.score = n, this.buffer = $, this.bufferBase = l, this.curContext = h, this.lookAhead = c, this.parent = a;
  }
  /**
  @internal
  */
  toString() {
    return `[${this.stack.filter((t, e) => e % 3 == 0).concat(this.state)}]@${this.pos}${this.score ? "!" + this.score : ""}`;
  }
  // Start an empty stack
  /**
  @internal
  */
  static start(t, e, s = 0) {
    let r = t.parser.context;
    return new Tt(t, [], e, s, s, 0, [], 0, r ? new me(r, r.start) : null, 0, null);
  }
  /**
  The stack's current [context](#lr.ContextTracker) value, if
  any. Its type will depend on the context tracker's type
  parameter, or it will be `null` if there is no context
  tracker.
  */
  get context() {
    return this.curContext ? this.curContext.context : null;
  }
  // Push a state onto the stack, tracking its start position as well
  // as the buffer base at that point.
  /**
  @internal
  */
  pushState(t, e) {
    this.stack.push(this.state, e, this.bufferBase + this.buffer.length), this.state = t;
  }
  // Apply a reduce action
  /**
  @internal
  */
  reduce(t) {
    var e;
    let s = t >> 19, r = t & 65535, { parser: i } = this.p, n = i.dynamicPrecedence(r);
    if (n && (this.score += n), s == 0) {
      this.pushState(i.getGoto(this.state, r, !0), this.reducePos), r < i.minRepeatTerm && this.storeNode(r, this.reducePos, this.reducePos, 4, !0), this.reduceContext(r, this.reducePos);
      return;
    }
    let $ = this.stack.length - (s - 1) * 3 - (t & 262144 ? 6 : 0), l = $ ? this.stack[$ - 2] : this.p.ranges[0].from, h = this.reducePos - l;
    h >= 2e3 && !(!((e = this.p.parser.nodeSet.types[r]) === null || e === void 0) && e.isAnonymous) && (l == this.p.lastBigReductionStart ? (this.p.bigReductionCount++, this.p.lastBigReductionSize = h) : this.p.lastBigReductionSize < h && (this.p.bigReductionCount = 1, this.p.lastBigReductionStart = l, this.p.lastBigReductionSize = h));
    let c = $ ? this.stack[$ - 1] : 0, a = this.bufferBase + this.buffer.length - c;
    if (r < i.minRepeatTerm || t & 131072) {
      let f = i.stateFlag(
        this.state,
        1
        /* StateFlag.Skipped */
      ) ? this.pos : this.reducePos;
      this.storeNode(r, l, f, a + 4, !0);
    }
    if (t & 262144)
      this.state = this.stack[$];
    else {
      let f = this.stack[$ - 3];
      this.state = i.getGoto(f, r, !0);
    }
    for (; this.stack.length > $; )
      this.stack.pop();
    this.reduceContext(r, l);
  }
  // Shift a value into the buffer
  /**
  @internal
  */
  storeNode(t, e, s, r = 4, i = !1) {
    if (t == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      let n = this, $ = this.buffer.length;
      if ($ == 0 && n.parent && ($ = n.bufferBase - n.parent.bufferBase, n = n.parent), $ > 0 && n.buffer[$ - 4] == 0 && n.buffer[$ - 1] > -1) {
        if (e == s)
          return;
        if (n.buffer[$ - 2] >= e) {
          n.buffer[$ - 2] = s;
          return;
        }
      }
    }
    if (!i || this.pos == s)
      this.buffer.push(t, e, s, r);
    else {
      let n = this.buffer.length;
      if (n > 0 && this.buffer[n - 4] != 0)
        for (; n > 0 && this.buffer[n - 2] > s; )
          this.buffer[n] = this.buffer[n - 4], this.buffer[n + 1] = this.buffer[n - 3], this.buffer[n + 2] = this.buffer[n - 2], this.buffer[n + 3] = this.buffer[n - 1], n -= 4, r > 4 && (r -= 4);
      this.buffer[n] = t, this.buffer[n + 1] = e, this.buffer[n + 2] = s, this.buffer[n + 3] = r;
    }
  }
  // Apply a shift action
  /**
  @internal
  */
  shift(t, e, s, r) {
    if (t & 131072)
      this.pushState(t & 65535, this.pos);
    else if (t & 262144)
      this.pos = r, this.shiftContext(e, s), e <= this.p.parser.maxNode && this.buffer.push(e, s, r, 4);
    else {
      let i = t, { parser: n } = this.p;
      (r > this.pos || e <= n.maxNode) && (this.pos = r, n.stateFlag(
        i,
        1
        /* StateFlag.Skipped */
      ) || (this.reducePos = r)), this.pushState(i, s), this.shiftContext(e, s), e <= n.maxNode && this.buffer.push(e, s, r, 4);
    }
  }
  // Apply an action
  /**
  @internal
  */
  apply(t, e, s, r) {
    t & 65536 ? this.reduce(t) : this.shift(t, e, s, r);
  }
  // Add a prebuilt (reused) node into the buffer.
  /**
  @internal
  */
  useNode(t, e) {
    let s = this.p.reused.length - 1;
    (s < 0 || this.p.reused[s] != t) && (this.p.reused.push(t), s++);
    let r = this.pos;
    this.reducePos = this.pos = r + t.length, this.pushState(e, r), this.buffer.push(
      s,
      r,
      this.reducePos,
      -1
      /* size == -1 means this is a reused value */
    ), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, t, this, this.p.stream.reset(this.pos - t.length)));
  }
  // Split the stack. Due to the buffer sharing and the fact
  // that `this.stack` tends to stay quite shallow, this isn't very
  // expensive.
  /**
  @internal
  */
  split() {
    let t = this, e = t.buffer.length;
    for (; e > 0 && t.buffer[e - 2] > t.reducePos; )
      e -= 4;
    let s = t.buffer.slice(e), r = t.bufferBase + e;
    for (; t && r == t.bufferBase; )
      t = t.parent;
    return new Tt(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, s, r, this.curContext, this.lookAhead, t);
  }
  // Try to recover from an error by 'deleting' (ignoring) one token.
  /**
  @internal
  */
  recoverByDelete(t, e) {
    let s = t <= this.p.parser.maxNode;
    s && this.storeNode(t, this.pos, e, 4), this.storeNode(0, this.pos, e, s ? 8 : 4), this.pos = this.reducePos = e, this.score -= 190;
  }
  /**
  Check if the given term would be able to be shifted (optionally
  after some reductions) on this stack. This can be useful for
  external tokenizers that want to make sure they only provide a
  given token when it applies.
  */
  canShift(t) {
    for (let e = new ds(this); ; ) {
      let s = this.p.parser.stateSlot(
        e.state,
        4
        /* ParseState.DefaultReduce */
      ) || this.p.parser.hasAction(e.state, t);
      if (s == 0)
        return !1;
      if (!(s & 65536))
        return !0;
      e.reduce(s);
    }
  }
  // Apply up to Recover.MaxNext recovery actions that conceptually
  // inserts some missing token or rule.
  /**
  @internal
  */
  recoverByInsert(t) {
    if (this.stack.length >= 300)
      return [];
    let e = this.p.parser.nextStates(this.state);
    if (e.length > 8 || this.stack.length >= 120) {
      let r = [];
      for (let i = 0, n; i < e.length; i += 2)
        (n = e[i + 1]) != this.state && this.p.parser.hasAction(n, t) && r.push(e[i], n);
      if (this.stack.length < 120)
        for (let i = 0; r.length < 8 && i < e.length; i += 2) {
          let n = e[i + 1];
          r.some(($, l) => l & 1 && $ == n) || r.push(e[i], n);
        }
      e = r;
    }
    let s = [];
    for (let r = 0; r < e.length && s.length < 4; r += 2) {
      let i = e[r + 1];
      if (i == this.state)
        continue;
      let n = this.split();
      n.pushState(i, this.pos), n.storeNode(0, n.pos, n.pos, 4, !0), n.shiftContext(e[r], this.pos), n.reducePos = this.pos, n.score -= 200, s.push(n);
    }
    return s;
  }
  // Force a reduce, if possible. Return false if that can't
  // be done.
  /**
  @internal
  */
  forceReduce() {
    let { parser: t } = this.p, e = t.stateSlot(
      this.state,
      5
      /* ParseState.ForcedReduce */
    );
    if (!(e & 65536))
      return !1;
    if (!t.validAction(this.state, e)) {
      let s = e >> 19, r = e & 65535, i = this.stack.length - s * 3;
      if (i < 0 || t.getGoto(this.stack[i], r, !1) < 0) {
        let n = this.findForcedReduction();
        if (n == null)
          return !1;
        e = n;
      }
      this.storeNode(0, this.pos, this.pos, 4, !0), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(e), !0;
  }
  /**
  Try to scan through the automaton to find some kind of reduction
  that can be applied. Used when the regular ForcedReduce field
  isn't a valid action. @internal
  */
  findForcedReduction() {
    let { parser: t } = this.p, e = [], s = (r, i) => {
      if (!e.includes(r))
        return e.push(r), t.allActions(r, (n) => {
          if (!(n & 393216))
            if (n & 65536) {
              let $ = (n >> 19) - i;
              if ($ > 1) {
                let l = n & 65535, h = this.stack.length - $ * 3;
                if (h >= 0 && t.getGoto(this.stack[h], l, !1) >= 0)
                  return $ << 19 | 65536 | l;
              }
            } else {
              let $ = s(n, i + 1);
              if ($ != null)
                return $;
            }
        });
    };
    return s(this.state, 0);
  }
  /**
  @internal
  */
  forceAll() {
    for (; !this.p.parser.stateFlag(
      this.state,
      2
      /* StateFlag.Accepting */
    ); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, !0);
        break;
      }
    return this;
  }
  /**
  Check whether this state has no further actions (assumed to be a direct descendant of the
  top state, since any other states must be able to continue
  somehow). @internal
  */
  get deadEnd() {
    if (this.stack.length != 3)
      return !1;
    let { parser: t } = this.p;
    return t.data[t.stateSlot(
      this.state,
      1
      /* ParseState.Actions */
    )] == 65535 && !t.stateSlot(
      this.state,
      4
      /* ParseState.DefaultReduce */
    );
  }
  /**
  Restart the stack (put it back in its start state). Only safe
  when this.stack.length == 3 (state is directly below the top
  state). @internal
  */
  restart() {
    this.storeNode(0, this.pos, this.pos, 4, !0), this.state = this.stack[0], this.stack.length = 0;
  }
  /**
  @internal
  */
  sameState(t) {
    if (this.state != t.state || this.stack.length != t.stack.length)
      return !1;
    for (let e = 0; e < this.stack.length; e += 3)
      if (this.stack[e] != t.stack[e])
        return !1;
    return !0;
  }
  /**
  Get the parser used by this stack.
  */
  get parser() {
    return this.p.parser;
  }
  /**
  Test whether a given dialect (by numeric ID, as exported from
  the terms file) is enabled.
  */
  dialectEnabled(t) {
    return this.p.parser.dialect.flags[t];
  }
  shiftContext(t, e) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, t, this, this.p.stream.reset(e)));
  }
  reduceContext(t, e) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, t, this, this.p.stream.reset(e)));
  }
  /**
  @internal
  */
  emitContext() {
    let t = this.buffer.length - 1;
    (t < 0 || this.buffer[t] != -3) && this.buffer.push(this.curContext.hash, this.pos, this.pos, -3);
  }
  /**
  @internal
  */
  emitLookAhead() {
    let t = this.buffer.length - 1;
    (t < 0 || this.buffer[t] != -4) && this.buffer.push(this.lookAhead, this.pos, this.pos, -4);
  }
  updateContext(t) {
    if (t != this.curContext.context) {
      let e = new me(this.curContext.tracker, t);
      e.hash != this.curContext.hash && this.emitContext(), this.curContext = e;
    }
  }
  /**
  @internal
  */
  setLookAhead(t) {
    t > this.lookAhead && (this.emitLookAhead(), this.lookAhead = t);
  }
  /**
  @internal
  */
  close() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  }
}
class me {
  constructor(t, e) {
    this.tracker = t, this.context = e, this.hash = t.strict ? t.hash(e) : 0;
  }
}
class ds {
  constructor(t) {
    this.start = t, this.state = t.state, this.stack = t.stack, this.base = this.stack.length;
  }
  reduce(t) {
    let e = t & 65535, s = t >> 19;
    s == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= (s - 1) * 3;
    let r = this.start.p.parser.getGoto(this.stack[this.base - 3], e, !0);
    this.state = r;
  }
}
class Bt {
  constructor(t, e, s) {
    this.stack = t, this.pos = e, this.index = s, this.buffer = t.buffer, this.index == 0 && this.maybeNext();
  }
  static create(t, e = t.bufferBase + t.buffer.length) {
    return new Bt(t, e, e - t.bufferBase);
  }
  maybeNext() {
    let t = this.stack.parent;
    t != null && (this.index = this.stack.bufferBase - t.bufferBase, this.stack = t, this.buffer = t.buffer);
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  next() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  }
  fork() {
    return new Bt(this.stack, this.pos, this.index);
  }
}
function St(o, t = Uint16Array) {
  if (typeof o != "string")
    return o;
  let e = null;
  for (let s = 0, r = 0; s < o.length; ) {
    let i = 0;
    for (; ; ) {
      let n = o.charCodeAt(s++), $ = !1;
      if (n == 126) {
        i = 65535;
        break;
      }
      n >= 92 && n--, n >= 34 && n--;
      let l = n - 32;
      if (l >= 46 && (l -= 46, $ = !0), i += l, $)
        break;
      i *= 46;
    }
    e ? e[r++] = i : e = new t(i);
  }
  return e;
}
class yt {
  constructor() {
    this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
  }
}
const xe = new yt();
class Vs {
  /**
  @internal
  */
  constructor(t, e) {
    this.input = t, this.ranges = e, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = xe, this.rangeIndex = 0, this.pos = this.chunkPos = e[0].from, this.range = e[0], this.end = e[e.length - 1].to, this.readNext();
  }
  /**
  @internal
  */
  resolveOffset(t, e) {
    let s = this.range, r = this.rangeIndex, i = this.pos + t;
    for (; i < s.from; ) {
      if (!r)
        return null;
      let n = this.ranges[--r];
      i -= s.from - n.to, s = n;
    }
    for (; e < 0 ? i > s.to : i >= s.to; ) {
      if (r == this.ranges.length - 1)
        return null;
      let n = this.ranges[++r];
      i += n.from - s.to, s = n;
    }
    return i;
  }
  /**
  @internal
  */
  clipPos(t) {
    if (t >= this.range.from && t < this.range.to)
      return t;
    for (let e of this.ranges)
      if (e.to > t)
        return Math.max(t, e.from);
    return this.end;
  }
  /**
  Look at a code unit near the stream position. `.peek(0)` equals
  `.next`, `.peek(-1)` gives you the previous character, and so
  on.
  
  Note that looking around during tokenizing creates dependencies
  on potentially far-away content, which may reduce the
  effectiveness incremental parsing—when looking forward—or even
  cause invalid reparses when looking backward more than 25 code
  units, since the library does not track lookbehind.
  */
  peek(t) {
    let e = this.chunkOff + t, s, r;
    if (e >= 0 && e < this.chunk.length)
      s = this.pos + t, r = this.chunk.charCodeAt(e);
    else {
      let i = this.resolveOffset(t, 1);
      if (i == null)
        return -1;
      if (s = i, s >= this.chunk2Pos && s < this.chunk2Pos + this.chunk2.length)
        r = this.chunk2.charCodeAt(s - this.chunk2Pos);
      else {
        let n = this.rangeIndex, $ = this.range;
        for (; $.to <= s; )
          $ = this.ranges[++n];
        this.chunk2 = this.input.chunk(this.chunk2Pos = s), s + this.chunk2.length > $.to && (this.chunk2 = this.chunk2.slice(0, $.to - s)), r = this.chunk2.charCodeAt(0);
      }
    }
    return s >= this.token.lookAhead && (this.token.lookAhead = s + 1), r;
  }
  /**
  Accept a token. By default, the end of the token is set to the
  current stream position, but you can pass an offset (relative to
  the stream position) to change that.
  */
  acceptToken(t, e = 0) {
    let s = e ? this.resolveOffset(e, -1) : this.pos;
    if (s == null || s < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = t, this.token.end = s;
  }
  getChunk() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      let { chunk: t, chunkPos: e } = this;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = t, this.chunk2Pos = e, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      let t = this.input.chunk(this.pos), e = this.pos + t.length;
      this.chunk = e > this.range.to ? t.slice(0, this.range.to - this.pos) : t, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  }
  readNext() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  }
  /**
  Move the stream forward N (defaults to 1) code units. Returns
  the new value of [`next`](#lr.InputStream.next).
  */
  advance(t = 1) {
    for (this.chunkOff += t; this.pos + t >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      t -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += t, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  }
  setDone() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  }
  /**
  @internal
  */
  reset(t, e) {
    if (e ? (this.token = e, e.start = t, e.lookAhead = t + 1, e.value = e.extended = -1) : this.token = xe, this.pos != t) {
      if (this.pos = t, t == this.end)
        return this.setDone(), this;
      for (; t < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; t >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      t >= this.chunkPos && t < this.chunkPos + this.chunk.length ? this.chunkOff = t - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  }
  /**
  @internal
  */
  read(t, e) {
    if (t >= this.chunkPos && e <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(t - this.chunkPos, e - this.chunkPos);
    if (t >= this.chunk2Pos && e <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(t - this.chunk2Pos, e - this.chunk2Pos);
    if (t >= this.range.from && e <= this.range.to)
      return this.input.read(t, e);
    let s = "";
    for (let r of this.ranges) {
      if (r.from >= e)
        break;
      r.to > t && (s += this.input.read(Math.max(r.from, t), Math.min(r.to, e)));
    }
    return s;
  }
}
class ut {
  constructor(t, e) {
    this.data = t, this.id = e;
  }
  token(t, e) {
    let { parser: s } = e.p;
    Ws(this.data, t, e, this.id, s.data, s.tokenPrecTable);
  }
}
ut.prototype.contextual = ut.prototype.fallback = ut.prototype.extend = !1;
ut.prototype.fallback = ut.prototype.extend = !1;
function Ws(o, t, e, s, r, i) {
  let n = 0, $ = 1 << s, { dialect: l } = e.p.parser;
  t:
    for (; $ & o[n]; ) {
      let h = o[n + 1];
      for (let p = n + 3; p < h; p += 2)
        if ((o[p + 1] & $) > 0) {
          let V = o[p];
          if (l.allows(V) && (t.token.value == -1 || t.token.value == V || Os(V, t.token.value, r, i))) {
            t.acceptToken(V);
            break;
          }
        }
      let c = t.next, a = 0, f = o[n + 2];
      if (t.next < 0 && f > a && o[h + f * 3 - 3] == 65535) {
        n = o[h + f * 3 - 1];
        continue t;
      }
      for (; a < f; ) {
        let p = a + f >> 1, V = h + p + (p << 1), m = o[V], F = o[V + 1] || 65536;
        if (c < m)
          f = p;
        else if (c >= F)
          a = p + 1;
        else {
          n = o[V + 2], t.advance();
          continue t;
        }
      }
      break;
    }
}
function Se(o, t, e) {
  for (let s = t, r; (r = o[s]) != 65535; s++)
    if (r == e)
      return s - t;
  return -1;
}
function Os(o, t, e, s) {
  let r = Se(e, s, t);
  return r < 0 || Se(e, s, o) < r;
}
const v = typeof process < "u" && process.env && /\bparse\b/.test(process.env.LOG);
let Ct = null;
function be(o, t, e) {
  let s = o.cursor(T.IncludeAnonymous);
  for (s.moveTo(t); ; )
    if (!(e < 0 ? s.childBefore(t) : s.childAfter(t)))
      for (; ; ) {
        if ((e < 0 ? s.to < t : s.from > t) && !s.type.isError)
          return e < 0 ? Math.max(0, Math.min(
            s.to - 1,
            t - 25
            /* Safety.Margin */
          )) : Math.min(o.length, Math.max(
            s.from + 1,
            t + 25
            /* Safety.Margin */
          ));
        if (e < 0 ? s.prevSibling() : s.nextSibling())
          break;
        if (!s.parent())
          return e < 0 ? 0 : o.length;
      }
}
class gs {
  constructor(t, e) {
    this.fragments = t, this.nodeSet = e, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  nextFragment() {
    let t = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (t) {
      for (this.safeFrom = t.openStart ? be(t.tree, t.from + t.offset, 1) - t.offset : t.from, this.safeTo = t.openEnd ? be(t.tree, t.to + t.offset, -1) - t.offset : t.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(t.tree), this.start.push(-t.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  }
  // `pos` must be >= any previously given `pos` for this cursor
  nodeAt(t) {
    if (t < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= t; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      let e = this.trees.length - 1;
      if (e < 0)
        return this.nextFragment(), null;
      let s = this.trees[e], r = this.index[e];
      if (r == s.children.length) {
        this.trees.pop(), this.start.pop(), this.index.pop();
        continue;
      }
      let i = s.children[r], n = this.start[e] + s.positions[r];
      if (n > t)
        return this.nextStart = n, null;
      if (i instanceof k) {
        if (n == t) {
          if (n < this.safeFrom)
            return null;
          let $ = n + i.length;
          if ($ <= this.safeTo) {
            let l = i.prop(b.lookAhead);
            if (!l || $ + l < this.fragment.to)
              return i;
          }
        }
        this.index[e]++, n + i.length >= Math.max(this.safeFrom, t) && (this.trees.push(i), this.start.push(n), this.index.push(0));
      } else
        this.index[e]++, this.nextStart = n + i.length;
    }
  }
}
class ms {
  constructor(t, e) {
    this.stream = e, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = t.tokenizers.map((s) => new yt());
  }
  getActions(t) {
    let e = 0, s = null, { parser: r } = t.p, { tokenizers: i } = r, n = r.stateSlot(
      t.state,
      3
      /* ParseState.TokenizerMask */
    ), $ = t.curContext ? t.curContext.hash : 0, l = 0;
    for (let h = 0; h < i.length; h++) {
      if (!(1 << h & n))
        continue;
      let c = i[h], a = this.tokens[h];
      if (!(s && !c.fallback) && ((c.contextual || a.start != t.pos || a.mask != n || a.context != $) && (this.updateCachedToken(a, c, t), a.mask = n, a.context = $), a.lookAhead > a.end + 25 && (l = Math.max(a.lookAhead, l)), a.value != 0)) {
        let f = e;
        if (a.extended > -1 && (e = this.addActions(t, a.extended, a.end, e)), e = this.addActions(t, a.value, a.end, e), !c.extend && (s = a, e > f))
          break;
      }
    }
    for (; this.actions.length > e; )
      this.actions.pop();
    return l && t.setLookAhead(l), !s && t.pos == this.stream.end && (s = new yt(), s.value = t.p.parser.eofTerm, s.start = s.end = t.pos, e = this.addActions(t, s.value, s.end, e)), this.mainToken = s, this.actions;
  }
  getMainToken(t) {
    if (this.mainToken)
      return this.mainToken;
    let e = new yt(), { pos: s, p: r } = t;
    return e.start = s, e.end = Math.min(s + 1, r.stream.end), e.value = s == r.stream.end ? r.parser.eofTerm : 0, e;
  }
  updateCachedToken(t, e, s) {
    let r = this.stream.clipPos(s.pos);
    if (e.token(this.stream.reset(r, t), s), t.value > -1) {
      let { parser: i } = s.p;
      for (let n = 0; n < i.specialized.length; n++)
        if (i.specialized[n] == t.value) {
          let $ = i.specializers[n](this.stream.read(t.start, t.end), s);
          if ($ >= 0 && s.p.parser.dialect.allows($ >> 1)) {
            $ & 1 ? t.extended = $ >> 1 : t.value = $ >> 1;
            break;
          }
        }
    } else
      t.value = 0, t.end = this.stream.clipPos(r + 1);
  }
  putAction(t, e, s, r) {
    for (let i = 0; i < r; i += 3)
      if (this.actions[i] == t)
        return r;
    return this.actions[r++] = t, this.actions[r++] = e, this.actions[r++] = s, r;
  }
  addActions(t, e, s, r) {
    let { state: i } = t, { parser: n } = t.p, { data: $ } = n;
    for (let l = 0; l < 2; l++)
      for (let h = n.stateSlot(
        i,
        l ? 2 : 1
        /* ParseState.Actions */
      ); ; h += 3) {
        if ($[h] == 65535)
          if ($[h + 1] == 1)
            h = Q($, h + 2);
          else {
            r == 0 && $[h + 1] == 2 && (r = this.putAction(Q($, h + 2), e, s, r));
            break;
          }
        $[h] == e && (r = this.putAction(Q($, h + 1), e, s, r));
      }
    return r;
  }
}
class xs {
  constructor(t, e, s, r) {
    this.parser = t, this.input = e, this.ranges = r, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.lastBigReductionStart = -1, this.lastBigReductionSize = 0, this.bigReductionCount = 0, this.stream = new Vs(e, r), this.tokens = new ms(t, this.stream), this.topTerm = t.top[1];
    let { from: i } = r[0];
    this.stacks = [Tt.start(this, t.top[0], i)], this.fragments = s.length && this.stream.end - i > t.bufferLength * 4 ? new gs(s, t.nodeSet) : null;
  }
  get parsedPos() {
    return this.minStackPos;
  }
  // Move the parser forward. This will process all parse stacks at
  // `this.pos` and try to advance them to a further position. If no
  // stack for such a position is found, it'll start error-recovery.
  //
  // When the parse is finished, this will return a syntax tree. When
  // not, it returns `null`.
  advance() {
    let t = this.stacks, e = this.minStackPos, s = this.stacks = [], r, i;
    if (this.bigReductionCount > 300 && t.length == 1) {
      let [n] = t;
      for (; n.forceReduce() && n.stack.length && n.stack[n.stack.length - 2] >= this.lastBigReductionStart; )
        ;
      this.bigReductionCount = this.lastBigReductionSize = 0;
    }
    for (let n = 0; n < t.length; n++) {
      let $ = t[n];
      for (; ; ) {
        if (this.tokens.mainToken = null, $.pos > e)
          s.push($);
        else {
          if (this.advanceStack($, s, t))
            continue;
          {
            r || (r = [], i = []), r.push($);
            let l = this.tokens.getMainToken($);
            i.push(l.value, l.end);
          }
        }
        break;
      }
    }
    if (!s.length) {
      let n = r && bs(r);
      if (n)
        return v && console.log("Finish with " + this.stackID(n)), this.stackToTree(n);
      if (this.parser.strict)
        throw v && r && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + e);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && r) {
      let n = this.stoppedAt != null && r[0].pos > this.stoppedAt ? r[0] : this.runRecovery(r, i, s);
      if (n)
        return v && console.log("Force-finish " + this.stackID(n)), this.stackToTree(n.forceAll());
    }
    if (this.recovering) {
      let n = this.recovering == 1 ? 1 : this.recovering * 3;
      if (s.length > n)
        for (s.sort(($, l) => l.score - $.score); s.length > n; )
          s.pop();
      s.some(($) => $.reducePos > e) && this.recovering--;
    } else if (s.length > 1) {
      t:
        for (let n = 0; n < s.length - 1; n++) {
          let $ = s[n];
          for (let l = n + 1; l < s.length; l++) {
            let h = s[l];
            if ($.sameState(h) || $.buffer.length > 500 && h.buffer.length > 500)
              if (($.score - h.score || $.buffer.length - h.buffer.length) > 0)
                s.splice(l--, 1);
              else {
                s.splice(n--, 1);
                continue t;
              }
          }
        }
      s.length > 12 && s.splice(
        12,
        s.length - 12
        /* Rec.MaxStackCount */
      );
    }
    this.minStackPos = s[0].pos;
    for (let n = 1; n < s.length; n++)
      s[n].pos < this.minStackPos && (this.minStackPos = s[n].pos);
    return null;
  }
  stopAt(t) {
    if (this.stoppedAt != null && this.stoppedAt < t)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = t;
  }
  // Returns an updated version of the given stack, or null if the
  // stack can't advance normally. When `split` and `stacks` are
  // given, stacks split off by ambiguous operations will be pushed to
  // `split`, or added to `stacks` if they move `pos` forward.
  advanceStack(t, e, s) {
    let r = t.pos, { parser: i } = this, n = v ? this.stackID(t) + " -> " : "";
    if (this.stoppedAt != null && r > this.stoppedAt)
      return t.forceReduce() ? t : null;
    if (this.fragments) {
      let h = t.curContext && t.curContext.tracker.strict, c = h ? t.curContext.hash : 0;
      for (let a = this.fragments.nodeAt(r); a; ) {
        let f = this.parser.nodeSet.types[a.type.id] == a.type ? i.getGoto(t.state, a.type.id) : -1;
        if (f > -1 && a.length && (!h || (a.prop(b.contextHash) || 0) == c))
          return t.useNode(a, f), v && console.log(n + this.stackID(t) + ` (via reuse of ${i.getName(a.type.id)})`), !0;
        if (!(a instanceof k) || a.children.length == 0 || a.positions[0] > 0)
          break;
        let p = a.children[0];
        if (p instanceof k && a.positions[0] == 0)
          a = p;
        else
          break;
      }
    }
    let $ = i.stateSlot(
      t.state,
      4
      /* ParseState.DefaultReduce */
    );
    if ($ > 0)
      return t.reduce($), v && console.log(n + this.stackID(t) + ` (via always-reduce ${i.getName(
        $ & 65535
        /* Action.ValueMask */
      )})`), !0;
    if (t.stack.length >= 8400)
      for (; t.stack.length > 6e3 && t.forceReduce(); )
        ;
    let l = this.tokens.getActions(t);
    for (let h = 0; h < l.length; ) {
      let c = l[h++], a = l[h++], f = l[h++], p = h == l.length || !s, V = p ? t : t.split(), m = this.tokens.mainToken;
      if (V.apply(c, a, m ? m.start : V.pos, f), v && console.log(n + this.stackID(V) + ` (via ${c & 65536 ? `reduce of ${i.getName(
        c & 65535
        /* Action.ValueMask */
      )}` : "shift"} for ${i.getName(a)} @ ${r}${V == t ? "" : ", split"})`), p)
        return !0;
      V.pos > r ? e.push(V) : s.push(V);
    }
    return !1;
  }
  // Advance a given stack forward as far as it will go. Returns the
  // (possibly updated) stack if it got stuck, or null if it moved
  // forward and was given to `pushStackDedup`.
  advanceFully(t, e) {
    let s = t.pos;
    for (; ; ) {
      if (!this.advanceStack(t, null, null))
        return !1;
      if (t.pos > s)
        return Ie(t, e), !0;
    }
  }
  runRecovery(t, e, s) {
    let r = null, i = !1;
    for (let n = 0; n < t.length; n++) {
      let $ = t[n], l = e[n << 1], h = e[(n << 1) + 1], c = v ? this.stackID($) + " -> " : "";
      if ($.deadEnd && (i || (i = !0, $.restart(), v && console.log(c + this.stackID($) + " (restarted)"), this.advanceFully($, s))))
        continue;
      let a = $.split(), f = c;
      for (let p = 0; a.forceReduce() && p < 10 && (v && console.log(f + this.stackID(a) + " (via force-reduce)"), !this.advanceFully(a, s)); p++)
        v && (f = this.stackID(a) + " -> ");
      for (let p of $.recoverByInsert(l))
        v && console.log(c + this.stackID(p) + " (via recover-insert)"), this.advanceFully(p, s);
      this.stream.end > $.pos ? (h == $.pos && (h++, l = 0), $.recoverByDelete(l, h), v && console.log(c + this.stackID($) + ` (via recover-delete ${this.parser.getName(l)})`), Ie($, s)) : (!r || r.score < $.score) && (r = $);
    }
    return r;
  }
  // Convert the stack's buffer to a syntax tree.
  stackToTree(t) {
    return t.close(), k.build({
      buffer: Bt.create(t),
      nodeSet: this.parser.nodeSet,
      topID: this.topTerm,
      maxBufferLength: this.parser.bufferLength,
      reused: this.reused,
      start: this.ranges[0].from,
      length: t.pos - this.ranges[0].from,
      minRepeatType: this.parser.minRepeatTerm
    });
  }
  stackID(t) {
    let e = (Ct || (Ct = /* @__PURE__ */ new WeakMap())).get(t);
    return e || Ct.set(t, e = String.fromCodePoint(this.nextStackID++)), e + t;
  }
}
function Ie(o, t) {
  for (let e = 0; e < t.length; e++) {
    let s = t[e];
    if (s.pos == o.pos && s.sameState(o)) {
      t[e].score < o.score && (t[e] = o);
      return;
    }
  }
  t.push(o);
}
class Ss {
  constructor(t, e, s) {
    this.source = t, this.flags = e, this.disabled = s;
  }
  allows(t) {
    return !this.disabled || this.disabled[t] == 0;
  }
}
class qt extends Qe {
  /**
  @internal
  */
  constructor(t) {
    if (super(), this.wrappers = [], t.version != 14)
      throw new RangeError(`Parser version (${t.version}) doesn't match runtime version (14)`);
    let e = t.nodeNames.split(" ");
    this.minRepeatTerm = e.length;
    for (let $ = 0; $ < t.repeatNodeCount; $++)
      e.push("");
    let s = Object.keys(t.topRules).map(($) => t.topRules[$][1]), r = [];
    for (let $ = 0; $ < e.length; $++)
      r.push([]);
    function i($, l, h) {
      r[$].push([l, l.deserialize(String(h))]);
    }
    if (t.nodeProps)
      for (let $ of t.nodeProps) {
        let l = $[0];
        typeof l == "string" && (l = b[l]);
        for (let h = 1; h < $.length; ) {
          let c = $[h++];
          if (c >= 0)
            i(c, l, $[h++]);
          else {
            let a = $[h + -c];
            for (let f = -c; f > 0; f--)
              i($[h++], l, a);
            h++;
          }
        }
      }
    this.nodeSet = new he(e.map(($, l) => R.define({
      name: l >= this.minRepeatTerm ? void 0 : $,
      id: l,
      props: r[l],
      top: s.indexOf(l) > -1,
      error: l == 0,
      skipped: t.skippedNodes && t.skippedNodes.indexOf(l) > -1
    }))), t.propSources && (this.nodeSet = this.nodeSet.extend(...t.propSources)), this.strict = !1, this.bufferLength = Ce;
    let n = St(t.tokenData);
    this.context = t.context, this.specializerSpecs = t.specialized || [], this.specialized = new Uint16Array(this.specializerSpecs.length);
    for (let $ = 0; $ < this.specializerSpecs.length; $++)
      this.specialized[$] = this.specializerSpecs[$].term;
    this.specializers = this.specializerSpecs.map(Pe), this.states = St(t.states, Uint32Array), this.data = St(t.stateData), this.goto = St(t.goto), this.maxTerm = t.maxTerm, this.tokenizers = t.tokenizers.map(($) => typeof $ == "number" ? new ut(n, $) : $), this.topRules = t.topRules, this.dialects = t.dialects || {}, this.dynamicPrecedences = t.dynamicPrecedences || null, this.tokenPrecTable = t.tokenPrec, this.termNames = t.termNames || null, this.maxNode = this.nodeSet.types.length - 1, this.dialect = this.parseDialect(), this.top = this.topRules[Object.keys(this.topRules)[0]];
  }
  createParse(t, e, s) {
    let r = new xs(this, t, e, s);
    for (let i of this.wrappers)
      r = i(r, t, e, s);
    return r;
  }
  /**
  Get a goto table entry @internal
  */
  getGoto(t, e, s = !1) {
    let r = this.goto;
    if (e >= r[0])
      return -1;
    for (let i = r[e + 1]; ; ) {
      let n = r[i++], $ = n & 1, l = r[i++];
      if ($ && s)
        return l;
      for (let h = i + (n >> 1); i < h; i++)
        if (r[i] == t)
          return l;
      if ($)
        return -1;
    }
  }
  /**
  Check if this state has an action for a given terminal @internal
  */
  hasAction(t, e) {
    let s = this.data;
    for (let r = 0; r < 2; r++)
      for (let i = this.stateSlot(
        t,
        r ? 2 : 1
        /* ParseState.Actions */
      ), n; ; i += 3) {
        if ((n = s[i]) == 65535)
          if (s[i + 1] == 1)
            n = s[i = Q(s, i + 2)];
          else {
            if (s[i + 1] == 2)
              return Q(s, i + 2);
            break;
          }
        if (n == e || n == 0)
          return Q(s, i + 1);
      }
    return 0;
  }
  /**
  @internal
  */
  stateSlot(t, e) {
    return this.states[t * 6 + e];
  }
  /**
  @internal
  */
  stateFlag(t, e) {
    return (this.stateSlot(
      t,
      0
      /* ParseState.Flags */
    ) & e) > 0;
  }
  /**
  @internal
  */
  validAction(t, e) {
    return !!this.allActions(t, (s) => s == e ? !0 : null);
  }
  /**
  @internal
  */
  allActions(t, e) {
    let s = this.stateSlot(
      t,
      4
      /* ParseState.DefaultReduce */
    ), r = s ? e(s) : void 0;
    for (let i = this.stateSlot(
      t,
      1
      /* ParseState.Actions */
    ); r == null; i += 3) {
      if (this.data[i] == 65535)
        if (this.data[i + 1] == 1)
          i = Q(this.data, i + 2);
        else
          break;
      r = e(Q(this.data, i + 1));
    }
    return r;
  }
  /**
  Get the states that can follow this one through shift actions or
  goto jumps. @internal
  */
  nextStates(t) {
    let e = [];
    for (let s = this.stateSlot(
      t,
      1
      /* ParseState.Actions */
    ); ; s += 3) {
      if (this.data[s] == 65535)
        if (this.data[s + 1] == 1)
          s = Q(this.data, s + 2);
        else
          break;
      if (!(this.data[s + 2] & 1)) {
        let r = this.data[s + 1];
        e.some((i, n) => n & 1 && i == r) || e.push(this.data[s], r);
      }
    }
    return e;
  }
  /**
  Configure the parser. Returns a new parser instance that has the
  given settings modified. Settings not provided in `config` are
  kept from the original parser.
  */
  configure(t) {
    let e = Object.assign(Object.create(qt.prototype), this);
    if (t.props && (e.nodeSet = this.nodeSet.extend(...t.props)), t.top) {
      let s = this.topRules[t.top];
      if (!s)
        throw new RangeError(`Invalid top rule name ${t.top}`);
      e.top = s;
    }
    return t.tokenizers && (e.tokenizers = this.tokenizers.map((s) => {
      let r = t.tokenizers.find((i) => i.from == s);
      return r ? r.to : s;
    })), t.specializers && (e.specializers = this.specializers.slice(), e.specializerSpecs = this.specializerSpecs.map((s, r) => {
      let i = t.specializers.find(($) => $.from == s.external);
      if (!i)
        return s;
      let n = Object.assign(Object.assign({}, s), { external: i.to });
      return e.specializers[r] = Pe(n), n;
    })), t.contextTracker && (e.context = t.contextTracker), t.dialect && (e.dialect = this.parseDialect(t.dialect)), t.strict != null && (e.strict = t.strict), t.wrap && (e.wrappers = e.wrappers.concat(t.wrap)), t.bufferLength != null && (e.bufferLength = t.bufferLength), e;
  }
  /**
  Tells you whether any [parse wrappers](#lr.ParserConfig.wrap)
  are registered for this parser.
  */
  hasWrappers() {
    return this.wrappers.length > 0;
  }
  /**
  Returns the name associated with a given term. This will only
  work for all terms when the parser was generated with the
  `--names` option. By default, only the names of tagged terms are
  stored.
  */
  getName(t) {
    return this.termNames ? this.termNames[t] : String(t <= this.maxNode && this.nodeSet.types[t].name || t);
  }
  /**
  The eof term id is always allocated directly after the node
  types. @internal
  */
  get eofTerm() {
    return this.maxNode + 1;
  }
  /**
  The type of top node produced by the parser.
  */
  get topNode() {
    return this.nodeSet.types[this.top[1]];
  }
  /**
  @internal
  */
  dynamicPrecedence(t) {
    let e = this.dynamicPrecedences;
    return e == null ? 0 : e[t] || 0;
  }
  /**
  @internal
  */
  parseDialect(t) {
    let e = Object.keys(this.dialects), s = e.map(() => !1);
    if (t)
      for (let i of t.split(" ")) {
        let n = e.indexOf(i);
        n >= 0 && (s[n] = !0);
      }
    let r = null;
    for (let i = 0; i < e.length; i++)
      if (!s[i])
        for (let n = this.dialects[e[i]], $; ($ = this.data[n++]) != 65535; )
          (r || (r = new Uint8Array(this.maxTerm + 1)))[$] = 1;
    return new Ss(t, s, r);
  }
  /**
  Used by the output of the parser generator. Not available to
  user code. @hide
  */
  static deserialize(t) {
    return new qt(t);
  }
}
function Q(o, t) {
  return o[t] | o[t + 1] << 16;
}
function bs(o) {
  let t = null;
  for (let e of o) {
    let s = e.p.stoppedAt;
    (e.pos == e.p.stream.end || s != null && e.pos > s) && e.p.parser.stateFlag(
      e.state,
      2
      /* StateFlag.Accepting */
    ) && (!t || t.score < e.score) && (t = e);
  }
  return t;
}
function Pe(o) {
  if (o.external) {
    let t = o.extend ? 1 : 0;
    return (e, s) => o.external(e, s) << 1 | t;
  }
  return o.get;
}
const Yt = qt.deserialize({
  version: 14,
  states: "0tQQOPOOOOOO'#C^'#C^OOOO'#C`'#C`OOOO'#Cn'#CnO`OQO'#CpOOOO'#Co'#CoOhOSO'#C_OpOPO'#C{QOOOOOOOOO'#Cr'#CrO!ROSO,59[OcOQO,59`OOOO'#Cc'#CcO!ZOSO'#CbOkOSO'#CbO!fOQO,58yOOOO,59g,59gOOOO1G.v1G.vO!kOQO1G.vO!pOSO1G.zO!xOWO,58|O#TOQO,58|O#]OSO,58|OOOO'#Cw'#CwOOOO1G.e1G.eOOOO7+$b7+$bOOOO7+$f7+$fO#hOQO7+$fOOOO'#Ce'#CeO#mOSO1G.hO!{OWO1G.hOOOO'#Ch'#ChO#xOSO1G.mO$QOWO1G.hO$]OQO1G.hOOOO<<HQ<<HQO$eO`O7+$SO$mOQO7+$SO$uOSO7+$SO%QOSO7+$XO%YOpO7+$XO%eOQO7+$XO!{OWO7+$SO%jOWO7+$SOOOO'#Cf'#CfOOOO'#Cx'#CxO$hO`O'#CxO%uO`O<<GnO$eO`O<<GnO&QOQO<<GnO&YOpO<<GsO&eOQO<<GsOOOO'#Ci'#CiOOOO'#Ck'#CkO&jOSO'#CjOOOO'#Cy'#CyO%]OpO<<GsO&rOpO<<GsO&}OpO<<GsO'VOSO<<GnO'bOSO<<GsO!{OWO<<GnOOOO,59d,59dO'jO`OAN=YOOOO-E6v-E6vO'rO`OAN=YO$eO`OAN=YO%]OpOAN=_O'}OpOAN=_O&}OpOAN=_O(YOpOAN=_O(eO!bO,59UO(vOPO,59UOOOO,59e,59eO(QOpOAN=_OOOO-E6w-E6wO%`OpO'#CyO({OQOAN=YO)TOQOAN=_O)YOSOAN=YO)eOSOAN=_O)mO`OG22tO)uO`OG22tO&}OpOG22yO*QOpOG22yO*YOpOG22yO%]OpOG22yOOOO'#Cm'#CmO*eO!bO'#DUOOOO'#Cl'#ClO*vOQO1G.pO(eO!bO1G.pO$eO`OG22tO*{OpOG22yO+WOQOG22tO+`OQOG22yO+eO`OLD(`O+mOpOLD(eO+pOpOLD(eO&}OpOLD(eOOOO,59p,59pOOOO7+$[7+$[O+xOQO7+$[O+}O`OLD(`O%]OpOLD(eO$eO`OLD(`O,YOpOLD(eO,eOpO!$'LPO,mOpO!$'LPOOOO<<Gv<<GvO,xO`O!$'KzO&}OpO!$'LPO-QO`O!$'KzO%]OpO!$'LPO-]OpO!)9AkO-eOpO!)9AkO-pO`O!)9AfO&}OpO!)9AkO-xOpO!.K7VO.QOpO!.K7VO.]OpO!4/,q",
  stateData: ".h~OTQOeSOpPOzRO~OiZO{XO~Oq^Or[O~OTQOeSOpPOzROnoX~OgaOqbO~OWdOqeOjUX~OjgO~OgiO~OgjOqkO~OqnOslOuoO~OWqOjUa~OWqOqrOjUa~OgsO~OWtOquOjUi~OWxOqyO~OqzOslOuoO~OW{OjUi~Oq!OOt|O~OW!QOjUq~OW!QOq!ROjUq~OW!SOq!TO~Oq!YOv!UOw!VO~OW!SO~Oq!_OslOuoO~Oq!aOt|OjUy~OW!dOjUy~Oq!eOv!UOw!VO~OW!hO~OT!iOq!jO~Oq!lOw!VOjZy~Oq!nOw!VO~OW!dOq!oOjUy~OW!hOq!pO~Ot|OjU!R~Oq!sOt|OjU!R~Oq!vOw!VOjZ!R~Oq!xOv!UOw!VO~OTQOeSOy!yOzROj`P~OT!}O~OW#OOjU!R~OW#PO~OW#OOq#QOjU!R~OW#POq#RO~Ot|OjU!Z~Oq#SOt|OjU!Z~Ow!VOjZ!Z~Oq#UOw!VOjZ!Z~OTQOeSOy!yOzROjxX~Oj#XO~Oq#[Ov!UOw!VO~OW#]OjU!Z~OW#^O~Ot|OjU!c~Oq#_Ow!VOjZ!c~Oj#aO~Oq#bOt|OjU!c~Oq#eOv!UOw!VO~Ow!VOjZ!k~Oq#fOw!VOjZ!k~Ot|OjU!k~Oq#hOt|OjU!k~Ow!VOjZ!s~Oq#jOw!VOjZ!s~Ot|OjU!s~Ow!VOjZ!{~Oq#lOw!VOjZ!{~Ow!VOjZ#T~Ovw~",
  goto: "'hyPPz!O!XP!`!cP!i!w!`#]#k$R$v%i!S!O!O%oP%vP%oPP%|&P&gP'ZPPPPPPPP'aTVOVSVOVV!z!i!z!}ZUOV!i!z!}R_UQ]URf^QmdSvnqS!]z{R!q!_d}t!P!Q!c!d!t#O#Z#]#d]!`!O!a!s#S#b#hQpdSwnqS!^z{R!r!_Q![xS!g!S!YS!u!e!hS#V!x#PS#c#[#^R#i#et!Xx!S!Z![!f!g!h!u!w#P#T#V#^#`#c#g#i#kk!k!Y!e!l!n!v!x#U#[#_#e#f#j#l!a!Wx!S!Y!Z![!e!f!g!h!l!n!u!v!w!x#P#T#U#V#[#^#_#`#c#e#f#g#i#j#k#lQ!|!iR#Y!}ZTOV!i!z!}QYSRcZRh_Q!PtY!b!P!c!t#Z#dQ!c!QQ!t!dQ#Z#OR#d#]Q!ZxS!f!S![^!m!Z!f!w#T#`#g#kS!w!g!hS#T!u#PS#`#V#^Q#g#cR#k#iQWOR`VS!{!i!}R#W!z",
  nodeNames: "⚠ Program TextRoot Expression ExpressionOpen { FormatExpression Param Sep FormatFunction FormatStyle SelectExpression SelectFunction Offset SelectVariant VariantDescriptor VariantContent Text PluralPlaceholder HtmlTag HtmlTagOpen < TagName > HtmlTagClose Slash } ExpressionClose",
  maxTerm: 43,
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "'5n#sR#aOX(WX^@y^p(Wpq@yqs8VstCQtw8Vwx;wx|8V|}DW}!OEP!O!PEP!P!QLy!Q![! c![!^8V!^!_!([!_!`8V!`!a!)b!a!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#W! c#W#X!+z#X#b! c#b#c!GV#c#d#;b#d#e$>c#e#g! c#g#h%9`#h#i' x#i#o! c#o#p'/j#p#q8V#q#r'0p#r#s8V#s#y(W#y#z@y#z$f(W$f$g@y$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZ'1a#BZ$IS! c$IS$I_@y$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO@y$JO$JT(W$JT$JU@y$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW@y$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV@y&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#i(e!vt`rSy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!Q8V!Q![(W![!^8V!^!_:m!_!c8V!c!}(W!}#R8V#R#S(W#S#T8V#T#o(W#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%R(W%R%S8V%S%V(W%V%W8V%W%o(W%o%p8V%p&a(W&a&b8V&b#BY(W#BY#BZ-{#BZ$IS(W$IS$I_-{$I_$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg(W$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW%#t(W%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O(W&;O&=t8V&=t&FU(W&FU&FV-{&FV&FY8V&FY&F^(W&F^&Fw8V&Fw&GW(W&GW&GX8V&GX;'S(W;'S;=`@s<%l?>`(W?>`?>b8V?>b?DR(W?DR?DT8V?DTO(W!c.SYy!bpPOs-{tw-{wx.rx!^-{!_#o-{#p#q-{#q#r0d#r;'S-{;'S;=`7y<%lO-{!c.u_Os-{st/ttw-{wx-{x!^-{!^!_/t!_#o-{#o#p/t#p#q-{#q#r2s#r;'S-{;'S;=`7y<%l~-{~O-{~~0d!c/wVOw/twx-{x;'S/t;'S;=`0^<%l~/t~O/t~~0d!c0aP;=`<%l/tP0iWpPOs0dtw0dwx1Rx!^0d!_#o0d#p;'S0d;'S;=`2m<%lO0dP1U]Os0dst1}tw0dwx0dx!^0d!^!_1}!_#o0d#o#p1}#p;'S0d;'S;=`2m<%l~0d~O0d~~0dP2QVOw1}wx0dx;'S1};'S;=`2g<%l~1}~O1}~~0dP2jP;=`<%l1}P2pP;=`<%l0d!c2xZpPOs2sst3ktw2swx5wx!^2s!^!_3k!_#o2s#o#p3k#p;'S2s;'S;=`8P<%lO2s!b3nTOw3kwx3}x;'S3k;'S;=`5q<%lO3k!b4SXy!bOs3}tw3}wx4ox!^3}!_#o3}#p#q3}#r;'S3};'S;=`5k<%lO3}!b4r]Os3}st3ktw3}wx3}x!^3}!^!_3k!_#o3}#o#p3k#p#q3}#q#r3k#r;'S3};'S;=`5k<%lO3}!b5nP;=`<%l3}!b5tP;=`<%l3k!c5|_y!bOs-{st1}tw-{wx6{x!^-{!^!_1}!_#o-{#o#p1}#p#q-{#q#r0d#r;'S-{;'S;=`7y<%l~-{~O-{~~0d!c7Q]pPOs-{st3ktw-{wx5wx!^-{!^!_3k!_#o-{#o#p3k#p#q-{#q#r2s#r;'S-{;'S;=`7y<%lO-{!c7|P;=`<%l-{!c8SP;=`<%l2s!s8`st`y!bpPOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!^8V!^!_:m!_#o8V#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%lO8V`:r_t`OX:m^p:mq|:m}#q:m#r#y:m#z$f:m$g#BY:m#BZ$IS:m$I_$I|:m$JO$JT:m$JU$KV:m$KW&FU:m&FV;'S:m;'S;=`;q<%lO:m`;tP;=`<%l:m!s;|ut`OX8VX^-{^p8Vpq-{qs8Vst>atw8Vwx8Vx|8V|}-{}!^8V!^!_>a!_#o8V#o#p>a#p#q8V#q#r2s#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%l~8V~O8V~~0d!s>fot`OX>aX^/t^p>apq/tqw>awx8Vx|>a|}/t}#q>a#q#r/t#r#y>a#y#z/t#z$f>a$f$g/t$g#BY>a#BY#BZ/t#BZ$IS>a$IS$I_/t$I_$I|>a$I|$JO/t$JO$JT>a$JT$JU/t$JU$KV>a$KV$KW/t$KW&FU>a&FU&FV/t&FV;'S>a;'S;=`@g<%l~>a~O>a~~0d!s@jP;=`<%l>a!s@pP;=`<%l8V#i@vP;=`<%l(W#qASnq!^y!bpPOX-{X^@y^p-{pq@yqs-{tw-{wx.rx!^-{!_#o-{#p#q-{#q#r0d#r#y-{#y#z@y#z$f-{$f$g@y$g#BY-{#BY#BZ@y#BZ$IS-{$IS$I_@y$I_$I|-{$I|$JO@y$JO$JT-{$JT$JU@y$JU$KV-{$KV$KW@y$KW&FU-{&FU&FV@y&FV;'S-{;'S;=`7y<%lO-{!sCX_t`z!cOX:m^p:mq|:m}#q:m#r#y:m#z$f:m$g#BY:m#BZ$IS:m$I_$I|:m$JO$JT:m$JU$KV:m$KW&FU:m&FV;'S:m;'S;=`;q<%lO:m!iDaYWUy!bpPOs-{tw-{wx.rx!^-{!_#o-{#p#q-{#q#r0d#r;'S-{;'S;=`7y<%lO-{!uE[!dt`{Qy!bpPOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![EP![!^8V!^!_:m!_!c8V!c!}EP!}#R8V#R#SEP#S#T8V#T#oEP#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g$}8V$}%OEP%O%W8V%W%oEP%o%p8V%p&aEP&a&b8V&b4dEP4d4e8V4e#BYEP#BY#BZIj#BZ$ISEP$IS$I_-{$I_$I`8V$I`$IbEP$Ib$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$Je8V$Je$JgEP$Jg$KV8V$KV$KW-{$KW$Kh8V$Kh%#tEP%#t&/x8V&/x&EtEP&Et&FU8V&FU&FV-{&FV;'SEP;'S;:jLs;:j;=`@m<%l?&r8V?&r?AhEP?Ah?BY8V?BY?MnEP?MnO8V!eIs|{Qy!bpPOs-{tw-{wx.rx}-{}!OIj!O!PIj!P!Q-{!Q![Ij![!^-{!_!c-{!c!}Ij!}#R-{#R#SIj#S#T-{#T#oIj#p#q-{#q#r0d#r$}-{$}%OIj%O%W-{%W%oIj%o%p-{%p&aIj&a&b-{&b4dIj4d4e-{4e$ISIj$IS$I`-{$I`$IbIj$Ib$Je-{$Je$JgIj$Jg$Kh-{$Kh%#tIj%#t&/x-{&/x&EtIj&Et&FV-{&FV;'SIj;'S;:jLm;:j;=`7y<%l?&r-{?&r?AhIj?Ah?BY-{?BY?MnIj?MnO-{!eLpP;=`<%lIj!uLvP;=`<%lEP!uMUsiQt`y!bpPOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!^8V!^!_:m!_#o8V#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%lO8V#k! r#Ut`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k!(XP;=`<%l! c!s!(c_e!ct`OX:m^p:mq|:m}#q:m#r#y:m#z$f:m$g#BY:m#BZ$IS:m$I_$I|:m$JO$JT:m$JU$KV:m$KW&FU:m&FV;'S:m;'S;=`;q<%lO:m!y!)msgUt`y!bpPOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!^8V!^!_:m!_#o8V#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%lO8V#s!,Z#Vt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#U!2p#U#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s!3P#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#h! c#h#i!9i#i#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s!9x#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#X! c#X#Y!@b#Y#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s!@s#UsWt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s!Gf#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#i! c#i#j!NO#j#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s!N_#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#a! c#a#b#&w#b#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s#'W#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#U! c#U#V#-p#V#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s#.P#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#X! c#X#Y#4i#Y#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s#4x#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#f! c#f#g!@b#g#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k#;q#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#Y! c#Y#Z#BZ#Z#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k#Bj#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#Y! c#Y#Z#IS#Z#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k#Ic#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#g! c#g#h$ {#h#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k$![#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#X! c#X#Y$(t#Y#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k$)T#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#h! c#h#i$/m#i#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#k$/|#Vt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!]$6c!]!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#e$6lwt`y!bpPOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx{8V{|$9V|}-{}!O$9V!O!Q8V!Q![$;s![!^8V!^!_:m!_#o8V#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%lO8V#e$9`ut`y!bpPOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!Q8V!Q![$;s![!^8V!^!_:m!_#o8V#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%lO8V#e$<Out`y!bpPvpOX8VX^-{^p8Vpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!Q8V!Q![$;s![!^8V!^!_:m!_#o8V#o#p:m#p#q8V#q#r0d#r#y8V#y#z-{#z$f8V$f$g-{$g#BY8V#BY#BZ-{#BZ$IS8V$IS$I_-{$I_$I|8V$I|$JO-{$JO$JT8V$JT$JU-{$JU$KV8V$KV$KW-{$KW&FU8V&FU&FV-{&FV;'S8V;'S;=`@m<%lO8V#s$>r#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#`! c#`#a$E[#a#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s$Ek#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#i! c#i#j$LT#j#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s$Ld#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#f! c#f#g%$|#g#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%%]#Vt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#U%+r#U#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%,R#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#`! c#`#a%2k#a#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%2|#Ut`rSuW{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%9o#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#X! c#X#Y%@X#Y#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%@h#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#`! c#`#a%GQ#a#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%Ga#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#X! c#X#Y%My#Y#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s%NY#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#V! c#V#W&&r#W#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s&'R#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#h! c#h#i&-k#i#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s&-|#Wt`rSuW{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#c! c#c#d&4f#d#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s&4u#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#f! c#f#g&;_#g#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s&;n#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#W! c#W#X&BW#X#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s&Bg#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#]! c#]#^&IP#^#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s&I`#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#b! c#b#c%$|#c#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s'!X#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#]! c#]#^'(q#^#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W#s')Q#Wt`rS{Qy!bpPwpOX(WX^-{^p(Wpq-{qs8Vst:mtw8Vwx;wx|8V|}-{}!OEP!O!PEP!P!Q8V!Q![! c![!^8V!^!_:m!_!c8V!c!}! c!}#R8V#R#S! c#S#T8V#T#a! c#a#b!9i#b#o! c#o#p:m#p#q8V#q#r0d#r#s8V#s#y(W#y#z-{#z$f(W$f$g-{$g$n8V$n$o(W$o$p8V$p$q(W$q$s8V$s$t(W$t$u8V$u$v(W$v$x8V$x$|(W$|$}8V$}%O! c%O%R(W%R%S8V%S%V(W%V%W8V%W%o! c%o%p8V%p&a! c&a&b8V&b4d! c4d4e(W4e#BY! c#BY#BZIj#BZ$IS! c$IS$I_-{$I_$I`(W$I`$Ib! c$Ib$Id(W$Id$I|8V$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je8V$Je$Jg! c$Jg$Jz8V$Jz$J{(W$J{$KV8V$KV$KW-{$KW$Kh(W$Kh%#t! c%#t%3d8V%3d%6z(W%6z%Dl8V%Dl%E[(W%E[&/x8V&/x&;O! c&;O&=tEP&=t&Et! c&Et&FU(W&FU&FV-{&FV&FYEP&FY&F^! c&F^&FwEP&Fw&GW! c&GW&GXEP&GX;'S! c;'S;:j!(U;:j;=`@s<%l?&r(W?&r?>`! c?>`?>bEP?>b?Ah! c?Ah?BY(W?BY?DR! c?DR?DTEP?DT?Mn! c?MnO(W!w'/q_T!gt`OX:m^p:mq|:m}#q:m#r#y:m#z$f:m$g#BY:m#BZ$IS:m$I_$I|:m$JO$JT:m$JU$KV:m$KW&FU:m&FV;'S:m;'S;=`;q<%lO:m#k'0wWj#jpPOs0dtw0dwx1Rx!^0d!_#o0d#p;'S0d;'S;=`2m<%lO0d#s'1l!`q!^{Qy!bpPOX-{X^@y^p-{pq@yqs-{tw-{wx.rx}-{}!OIj!O!PIj!P!Q-{!Q![Ij![!^-{!_!c-{!c!}Ij!}#R-{#R#SIj#S#T-{#T#oIj#p#q-{#q#r0d#r#y-{#y#z@y#z$f-{$f$g@y$g$}-{$}%OIj%O%W-{%W%oIj%o%p-{%p&aIj&a&b-{&b4dIj4d4e-{4e#BYIj#BY#BZ'1a#BZ$ISIj$IS$I_@y$I_$I`-{$I`$IbIj$Ib$I|-{$I|$JO@y$JO$JT-{$JT$JU@y$JU$Je-{$Je$JgIj$Jg$KV-{$KV$KW@y$KW$Kh-{$Kh%#tIj%#t&/x-{&/x&EtIj&Et&FU-{&FU&FV@y&FV;'SIj;'S;:jLm;:j;=`7y<%l?&r-{?&r?AhIj?Ah?BY-{?BY?MnIj?MnO-{",
  tokenizers: [0, 1, 2, 3, 4, 5, 6],
  topRules: { Program: [0, 1] },
  tokenPrec: 619
}), fe = 3, Is = 6, pe = 7, Ps = 9, ws = 10, Ze = 12, Me = 14, Js = 16, ys = 18, Es = 19, ks = 20, Fs = 22;
function we(o) {
  const t = [];
  let e = o.firstChild;
  for (; e; )
    t.push(e), e = e.nextSibling;
  return t;
}
const Ts = (o) => {
  let t;
  try {
    t = Yt.configure({ strict: !0 }).parse(o);
  } catch {
    return null;
  }
  const e = [], s = /* @__PURE__ */ new Map();
  function r(c) {
    return o.substring(c.from, c.to);
  }
  function i(c) {
    const a = c.parent;
    let f = "", p;
    const V = [];
    we(c).forEach((F) => {
      const B = r(F);
      switch (F.type.id) {
        case pe:
          f = B;
          break;
        case Ps:
          p = B;
          break;
        case ws:
          V.push(B);
          break;
      }
    });
    const m = ["{", f];
    return p && (m.push(", "), m.push(p)), V.length && m.push(`, ${V.join(" ")}`), m.push("}"), {
      position: { start: a.from, end: a.to },
      type: "variable",
      name: f,
      normalizedValue: m.join("")
    };
  }
  function n(c) {
    const a = c.firstChild, f = we(a).find(
      (m) => m.type.id === Fs
    ), p = a.type.id === ks, V = r(f);
    return {
      position: { start: a.from, end: a.to },
      type: p ? "tagOpen" : "tagClose",
      name: V,
      normalizedValue: p ? `<${V}>` : `</${V}>`
    };
  }
  function $(c) {
    if (c.type === "tagOpen") {
      const a = s.get(c.name) ?? [];
      a.push(c), s.set(c.name, a);
    } else if (c.type === "tagClose") {
      const a = s.get(c.name);
      a ? (a.pop(), a.length === 0 && s.delete(c.name)) : c.error = "missing_open_tag";
    }
    e.push(c);
  }
  const l = t.cursor();
  let h;
  do {
    const c = l.node;
    switch (c.type.id) {
      case ys:
        $({
          name: "#",
          type: "hash",
          position: { start: l.from, end: l.to },
          normalizedValue: "#"
        }), h = !1;
        break;
      case fe: {
        const a = c.firstChild.nextSibling;
        (a == null ? void 0 : a.type.id) === Is && $(i(a)), h = !1;
        break;
      }
      case Es:
        $(n(c)), h = !1;
        break;
      default:
        h = !0;
        break;
    }
  } while (l.next(h));
  return s.forEach(
    (c) => c.forEach((a) => {
      a.error = "missing_close_tag";
    })
  ), e;
};
class Bs extends ns {
  constructor(t, e) {
    super(), this.value = t, this.examplePluralNum = e;
  }
  toDOM() {
    const t = document.createElement("span");
    let e = `placeholder-widget placeholder-${this.value.type}`;
    this.value.error && (e = e + ` placeholder-error placeholder-error-${this.value.error}`), t.className = e;
    const s = document.createElement("span");
    return s.textContent = this.value.type !== "hash" ? this.value.name : `#${this.examplePluralNum ?? ""}`, t.appendChild(s), t;
  }
}
function Je(o, t) {
  const e = Ts(o);
  return e === null ? null : e.filter((s) => {
    if (t) {
      const [r] = t;
      if (r > s.position.start && r < s.position.end)
        return !1;
    }
    return !0;
  });
}
function ye(o, t) {
  const e = new le();
  return o.forEach((s) => {
    e.add(
      s.position.start,
      s.position.end,
      G.widget({
        widget: new Bs(s, t),
        side: 1
      })
    );
  }), e.finish();
}
function qs(o, t) {
  return t.find((e) => e.name === o.name && e.type === e.type);
}
function Rs(o, t) {
  return t.find(
    (e) => e.name === o.name && e.type === o.type && e.position.start === e.position.start && e.position.end === e.position.end
  );
}
function zs(o, t, e) {
  return t.filter((s) => !!(Rs(s, o) || qs(s, e)));
}
function vs(o, t, e, s, r) {
  const i = e - t, $ = r - s - i;
  return o.filter((l) => t < l.position.end && e > l.position.start ? !1 : (e < l.position.start && (l.position.start += $, l.position.end += $), !0));
}
function Xt(o, t) {
  let e = o;
  return t.iterChanges((s, r, i, n) => {
    e = vs(e, s, r, i, n);
  }), e;
}
const mr = (o) => {
  const { noUpdates: t, allowedNewPlaceholders: e } = o || {};
  return Ae.define({
    create(s) {
      try {
        return Je(s.doc.toString(), void 0) || [];
      } catch {
        return [];
      }
    },
    update(s, r) {
      if (t)
        return Xt(s, r.changes);
      if (r.docChanged && !t) {
        let i;
        r.changes.iterChanges(($, l, h, c) => {
          const a = l - $;
          c - h - a <= 1 && (i = [h, c]);
        });
        const n = Je(
          r.state.doc.toString(),
          i
        );
        return n === null ? Xt(s, r.changes) : e ? zs(
          s,
          Xt(s, r.changes),
          e
        ) : n;
      }
      return s;
    },
    provide(s) {
      return Dt.fromClass(
        class {
          constructor(r) {
            mt(this, "decorationSet");
            this.decorationSet = ye(
              r.state.field(s),
              o == null ? void 0 : o.examplePluralNum
            );
          }
          update(r) {
            this.decorationSet = ye(
              r.state.field(s),
              o == null ? void 0 : o.examplePluralNum
            );
          }
        },
        {
          decorations: (r) => r.decorationSet,
          provide: (r) => nt.atomicRanges.of((i) => {
            var n;
            return ((n = i.plugin(r)) == null ? void 0 : n.decorationSet) || G.none;
          })
        }
      );
    }
  });
};
let Us = 0;
class X {
  /**
  @internal
  */
  constructor(t, e, s) {
    this.set = t, this.base = e, this.modified = s, this.id = Us++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(t) {
    if (t != null && t.base)
      throw new Error("Can not derive from a modified tag");
    let e = new X([], null, []);
    if (e.set.push(e), t)
      for (let s of t.set)
        e.set.push(s);
    return e;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let t = new Rt();
    return (e) => e.modified.indexOf(t) > -1 ? e : Rt.get(e.base || e, e.modified.concat(t).sort((s, r) => s.id - r.id));
  }
}
let Ds = 0;
class Rt {
  constructor() {
    this.instances = [], this.id = Ds++;
  }
  static get(t, e) {
    if (!e.length)
      return t;
    let s = e[0].instances.find(($) => $.base == t && _s(e, $.modified));
    if (s)
      return s;
    let r = [], i = new X(r, t, e);
    for (let $ of e)
      $.instances.push(i);
    let n = Ys(e);
    for (let $ of t.set)
      if (!$.modified.length)
        for (let l of n)
          r.push(Rt.get($, l));
    return i;
  }
}
function _s(o, t) {
  return o.length == t.length && o.every((e, s) => e == t[s]);
}
function Ys(o) {
  let t = [[]];
  for (let e = 0; e < o.length; e++)
    for (let s = 0, r = t.length; s < r; s++)
      t.push(t[s].concat(o[e]));
  return t.sort((e, s) => s.length - e.length);
}
function Le(o) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let e in o) {
    let s = o[e];
    Array.isArray(s) || (s = [s]);
    for (let r of e.split(" "))
      if (r) {
        let i = [], n = 2, $ = r;
        for (let a = 0; ; ) {
          if ($ == "..." && a > 0 && a + 3 == r.length) {
            n = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec($);
          if (!f)
            throw new RangeError("Invalid path: " + r);
          if (i.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), a += f[0].length, a == r.length)
            break;
          let p = r[a++];
          if (a == r.length && p == "!") {
            n = 0;
            break;
          }
          if (p != "/")
            throw new RangeError("Invalid path: " + r);
          $ = r.slice(a);
        }
        let l = i.length - 1, h = i[l];
        if (!h)
          throw new RangeError("Invalid path: " + r);
        let c = new zt(s, n, l > 0 ? i.slice(0, l) : null);
        t[h] = c.sort(t[h]);
      }
  }
  return He.add(t);
}
const He = new b();
class zt {
  constructor(t, e, s, r) {
    this.tags = t, this.mode = e, this.context = s, this.next = r;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(t) {
    return !t || t.depth < this.depth ? (this.next = t, this) : (t.next = this.sort(t.next), t);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
zt.empty = new zt([], 2, null);
function ts(o, t) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let i of o)
    if (!Array.isArray(i.tag))
      e[i.tag.id] = i.class;
    else
      for (let n of i.tag)
        e[n.id] = i.class;
  let { scope: s, all: r = null } = t || {};
  return {
    style: (i) => {
      let n = r;
      for (let $ of i)
        for (let l of $.set) {
          let h = e[l.id];
          if (h) {
            n = n ? n + " " + h : h;
            break;
          }
        }
      return n;
    },
    scope: s
  };
}
function Ks(o, t) {
  let e = null;
  for (let s of o) {
    let r = s.style(t);
    r && (e = e ? e + " " + r : r);
  }
  return e;
}
function As(o, t, e, s = 0, r = o.length) {
  let i = new js(s, Array.isArray(t) ? t : [t], e);
  i.highlightRange(o.cursor(), s, r, "", i.highlighters), i.flush(r);
}
class js {
  constructor(t, e, s) {
    this.at = t, this.highlighters = e, this.span = s, this.class = "";
  }
  startSpan(t, e) {
    e != this.class && (this.flush(t), t > this.at && (this.at = t), this.class = e);
  }
  flush(t) {
    t > this.at && this.class && this.span(this.at, t, this.class);
  }
  highlightRange(t, e, s, r, i) {
    let { type: n, from: $, to: l } = t;
    if ($ >= s || l <= e)
      return;
    n.isTop && (i = this.highlighters.filter((p) => !p.scope || p.scope(n)));
    let h = r, c = Cs(t) || zt.empty, a = Ks(i, c.tags);
    if (a && (h && (h += " "), h += a, c.mode == 1 && (r += (r ? " " : "") + a)), this.startSpan(Math.max(e, $), h), c.opaque)
      return;
    let f = t.tree && t.tree.prop(b.mounted);
    if (f && f.overlay) {
      let p = t.node.enter(f.overlay[0].from + $, 1), V = this.highlighters.filter((F) => !F.scope || F.scope(f.tree.type)), m = t.firstChild();
      for (let F = 0, B = $; ; F++) {
        let z = F < f.overlay.length ? f.overlay[F] : null, E = z ? z.from + $ : l, Y = Math.max(e, B), x = Math.min(s, E);
        if (Y < x && m)
          for (; t.from < x && (this.highlightRange(t, Y, x, r, i), this.startSpan(Math.min(x, t.to), h), !(t.to >= E || !t.nextSibling())); )
            ;
        if (!z || E > s)
          break;
        B = z.to + $, B > e && (this.highlightRange(p.cursor(), Math.max(e, z.from + $), Math.min(s, B), "", V), this.startSpan(Math.min(s, B), h));
      }
      m && t.parent();
    } else if (t.firstChild()) {
      f && (r = "");
      do
        if (!(t.to <= e)) {
          if (t.from >= s)
            break;
          this.highlightRange(t, e, s, r, i), this.startSpan(Math.min(s, t.to), h);
        }
      while (t.nextSibling());
      t.parent();
    }
  }
}
function Cs(o) {
  let t = o.type.prop(He);
  for (; t && t.context && !o.matchContext(t.context); )
    t = t.next;
  return t || null;
}
const u = X.define, bt = u(), M = u(), Ee = u(M), ke = u(M), L = u(), It = u(L), Gt = u(L), C = u(), it = u(C), A = u(), j = u(), re = u(), dt = u(re), Pt = u(), d = {
  /**
  A comment.
  */
  comment: bt,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: u(bt),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: u(bt),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: u(bt),
  /**
  Any kind of identifier.
  */
  name: M,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: u(M),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Ee,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: u(Ee),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: ke,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: u(ke),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: u(M),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: u(M),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: u(M),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: u(M),
  /**
  A literal value.
  */
  literal: L,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: It,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: u(It),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: u(It),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: u(It),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: Gt,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: u(Gt),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: u(Gt),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: u(L),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: u(L),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: u(L),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: u(L),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: u(L),
  /**
  A language keyword.
  */
  keyword: A,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: u(A),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: u(A),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: u(A),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: u(A),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: u(A),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: u(A),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: u(A),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: u(A),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: u(A),
  /**
  An operator.
  */
  operator: j,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: u(j),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: u(j),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: u(j),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: u(j),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: u(j),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: u(j),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: u(j),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: u(j),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: u(j),
  /**
  Program or markup punctuation.
  */
  punctuation: re,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: u(re),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: dt,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: u(dt),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: u(dt),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: u(dt),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: u(dt),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: C,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: it,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: u(it),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: u(it),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: u(it),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: u(it),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: u(it),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: u(it),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: u(C),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: u(C),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: u(C),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: u(C),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: u(C),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: u(C),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: u(C),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: u(C),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: u(),
  /**
  Deleted text.
  */
  deleted: u(),
  /**
  Changed text.
  */
  changed: u(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: u(),
  /**
  Metadata or meta-instruction.
  */
  meta: Pt,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: u(Pt),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: u(Pt),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: u(Pt),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: X.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: X.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: X.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: X.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: X.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: X.defineModifier()
};
ts([
  { tag: d.link, class: "tok-link" },
  { tag: d.heading, class: "tok-heading" },
  { tag: d.emphasis, class: "tok-emphasis" },
  { tag: d.strong, class: "tok-strong" },
  { tag: d.keyword, class: "tok-keyword" },
  { tag: d.atom, class: "tok-atom" },
  { tag: d.bool, class: "tok-bool" },
  { tag: d.url, class: "tok-url" },
  { tag: d.labelName, class: "tok-labelName" },
  { tag: d.inserted, class: "tok-inserted" },
  { tag: d.deleted, class: "tok-deleted" },
  { tag: d.literal, class: "tok-literal" },
  { tag: d.string, class: "tok-string" },
  { tag: d.number, class: "tok-number" },
  { tag: [d.regexp, d.escape, d.special(d.string)], class: "tok-string2" },
  { tag: d.variableName, class: "tok-variableName" },
  { tag: d.local(d.variableName), class: "tok-variableName tok-local" },
  { tag: d.definition(d.variableName), class: "tok-variableName tok-definition" },
  { tag: d.special(d.variableName), class: "tok-variableName2" },
  { tag: d.definition(d.propertyName), class: "tok-propertyName tok-definition" },
  { tag: d.typeName, class: "tok-typeName" },
  { tag: d.namespace, class: "tok-namespace" },
  { tag: d.className, class: "tok-className" },
  { tag: d.macroName, class: "tok-macroName" },
  { tag: d.propertyName, class: "tok-propertyName" },
  { tag: d.operator, class: "tok-operator" },
  { tag: d.comment, class: "tok-comment" },
  { tag: d.meta, class: "tok-meta" },
  { tag: d.invalid, class: "tok-invalid" },
  { tag: d.punctuation, class: "tok-punctuation" }
]);
const ie = "ͼ", Fe = typeof Symbol > "u" ? "__" + ie : Symbol.for(ie), ne = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), Te = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class Be {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(t, e) {
    this.rules = [];
    let { finish: s } = e || {};
    function r(n) {
      return /^@/.test(n) ? [n] : n.split(/,\s*/);
    }
    function i(n, $, l, h) {
      let c = [], a = /^@(\w+)\b/.exec(n[0]), f = a && a[1] == "keyframes";
      if (a && $ == null)
        return l.push(n[0] + ";");
      for (let p in $) {
        let V = $[p];
        if (/&/.test(p))
          i(
            p.split(/,\s*/).map((m) => n.map((F) => m.replace(/&/, F))).reduce((m, F) => m.concat(F)),
            V,
            l
          );
        else if (V && typeof V == "object") {
          if (!a)
            throw new RangeError("The value of a property (" + p + ") should be a primitive value.");
          i(r(p), V, c, f);
        } else
          V != null && c.push(p.replace(/_.*/, "").replace(/[A-Z]/g, (m) => "-" + m.toLowerCase()) + ": " + V + ";");
      }
      (c.length || f) && l.push((s && !a && !h ? n.map(s) : n).join(", ") + " {" + c.join(" ") + "}");
    }
    for (let n in t)
      i(r(n), t[n], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let t = Te[Fe] || 1;
    return Te[Fe] = t + 1, ie + t.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(t, e, s) {
    let r = t[ne], i = s && s.nonce;
    r ? i && r.setNonce(i) : r = new Xs(t, i), r.mount(Array.isArray(e) ? e : [e]);
  }
}
let qe = /* @__PURE__ */ new Map();
class Xs {
  constructor(t, e) {
    let s = t.ownerDocument || t, r = s.defaultView;
    if (!t.head && t.adoptedStyleSheets && r.CSSStyleSheet) {
      let i = qe.get(s);
      if (i)
        return t.adoptedStyleSheets = [i.sheet, ...t.adoptedStyleSheets], t[ne] = i;
      this.sheet = new r.CSSStyleSheet(), t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets], qe.set(s, this);
    } else {
      this.styleTag = s.createElement("style"), e && this.styleTag.setAttribute("nonce", e);
      let i = t.head || t;
      i.insertBefore(this.styleTag, i.firstChild);
    }
    this.modules = [], t[ne] = this;
  }
  mount(t) {
    let e = this.sheet, s = 0, r = 0;
    for (let i = 0; i < t.length; i++) {
      let n = t[i], $ = this.modules.indexOf(n);
      if ($ < r && $ > -1 && (this.modules.splice($, 1), r--, $ = -1), $ == -1) {
        if (this.modules.splice(r++, 0, n), e)
          for (let l = 0; l < n.rules.length; l++)
            e.insertRule(n.rules[l], s++);
      } else {
        for (; r < $; )
          s += this.modules[r++].rules.length;
        s += n.rules.length, r++;
      }
    }
    if (!e) {
      let i = "";
      for (let n = 0; n < this.modules.length; n++)
        i += this.modules[n].getRules() + `
`;
      this.styleTag.textContent = i;
    }
  }
  setNonce(t) {
    this.styleTag && this.styleTag.getAttribute("nonce") != t && this.styleTag.setAttribute("nonce", t);
  }
}
var Nt;
const ct = /* @__PURE__ */ new b();
function Gs(o) {
  return _t.define({
    combine: o ? (t) => t.concat(o) : void 0
  });
}
const Ns = /* @__PURE__ */ new b();
class _ {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(t, e, s = [], r = "") {
    this.data = t, this.name = r, At.prototype.hasOwnProperty("tree") || Object.defineProperty(At.prototype, "tree", { get() {
      return Z(this);
    } }), this.parser = e, this.extension = [
      pt.of(this),
      At.languageData.of((i, n, $) => {
        let l = Re(i, n, $), h = l.type.prop(ct);
        if (!h)
          return [];
        let c = i.facet(h), a = l.type.prop(Ns);
        if (a) {
          let f = l.resolve(n - l.from, $);
          for (let p of a)
            if (p.test(f, i)) {
              let V = i.facet(p.facet);
              return p.type == "replace" ? V : V.concat(c);
            }
        }
        return c;
      })
    ].concat(s);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(t, e, s = -1) {
    return Re(t, e, s).type.prop(ct) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(t) {
    let e = t.facet(pt);
    if ((e == null ? void 0 : e.data) == this.data)
      return [{ from: 0, to: t.doc.length }];
    if (!e || !e.allowsNesting)
      return [];
    let s = [], r = (i, n) => {
      if (i.prop(ct) == this.data) {
        s.push({ from: n, to: n + i.length });
        return;
      }
      let $ = i.prop(b.mounted);
      if ($) {
        if ($.tree.prop(ct) == this.data) {
          if ($.overlay)
            for (let l of $.overlay)
              s.push({ from: l.from + n, to: l.to + n });
          else
            s.push({ from: n, to: n + i.length });
          return;
        } else if ($.overlay) {
          let l = s.length;
          if (r($.tree, $.overlay[0].from + n), s.length > l)
            return;
        }
      }
      for (let l = 0; l < i.children.length; l++) {
        let h = i.children[l];
        h instanceof k && r(h, i.positions[l] + n);
      }
    };
    return r(Z(t), 0), s;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
_.setState = /* @__PURE__ */ $s.define();
function Re(o, t, e) {
  let s = o.facet(pt), r = Z(o).topNode;
  if (!s || s.allowsNesting)
    for (let i = r; i; i = i.enter(t, e, T.ExcludeBuffers))
      i.type.isTop && (r = i);
  return r;
}
class vt extends _ {
  constructor(t, e, s) {
    super(t, e, [], s), this.parser = e;
  }
  /**
  Define a language from a parser.
  */
  static define(t) {
    let e = Gs(t.languageData);
    return new vt(e, t.parser.configure({
      props: [ct.add((s) => s.isTop ? e : void 0)]
    }), t.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(t, e) {
    return new vt(this.data, this.parser.configure(t), e || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function Z(o) {
  let t = o.field(_.state, !1);
  return t ? t.tree : k.empty;
}
class Qs {
  /**
  Create an input object for the given document.
  */
  constructor(t) {
    this.doc = t, this.cursorPos = 0, this.string = "", this.cursor = t.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(t) {
    return this.string = this.cursor.next(t - this.cursorPos).value, this.cursorPos = t + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(t) {
    return this.syncTo(t), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(t, e) {
    let s = this.cursorPos - this.string.length;
    return t < s || e >= this.cursorPos ? this.doc.sliceString(t, e) : this.string.slice(t - s, e - s);
  }
}
let Vt = null;
class Ut {
  constructor(t, e, s = [], r, i, n, $, l) {
    this.parser = t, this.state = e, this.fragments = s, this.tree = r, this.treeLen = i, this.viewport = n, this.skipped = $, this.scheduleOn = l, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(t, e, s) {
    return new Ut(t, e, [], k.empty, 0, s, [], null);
  }
  startParse() {
    return this.parser.startParse(new Qs(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(t, e) {
    return e != null && e >= this.state.doc.length && (e = void 0), this.tree != k.empty && this.isDone(e ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var s;
      if (typeof t == "number") {
        let r = Date.now() + t;
        t = () => Date.now() > r;
      }
      for (this.parse || (this.parse = this.startParse()), e != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > e) && e < this.state.doc.length && this.parse.stopAt(e); ; ) {
        let r = this.parse.advance();
        if (r)
          if (this.fragments = this.withoutTempSkipped(ot.addTree(r, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (s = this.parse.stoppedAt) !== null && s !== void 0 ? s : this.state.doc.length, this.tree = r, this.parse = null, this.treeLen < (e ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (t())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let t, e;
    this.parse && (t = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > t) && this.parse.stopAt(t), this.withContext(() => {
      for (; !(e = this.parse.advance()); )
        ;
    }), this.treeLen = t, this.tree = e, this.fragments = this.withoutTempSkipped(ot.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(t) {
    let e = Vt;
    Vt = this;
    try {
      return t();
    } finally {
      Vt = e;
    }
  }
  withoutTempSkipped(t) {
    for (let e; e = this.tempSkipped.pop(); )
      t = ze(t, e.from, e.to);
    return t;
  }
  /**
  @internal
  */
  changes(t, e) {
    let { fragments: s, tree: r, treeLen: i, viewport: n, skipped: $ } = this;
    if (this.takeTree(), !t.empty) {
      let l = [];
      if (t.iterChangedRanges((h, c, a, f) => l.push({ fromA: h, toA: c, fromB: a, toB: f })), s = ot.applyChanges(s, l), r = k.empty, i = 0, n = { from: t.mapPos(n.from, -1), to: t.mapPos(n.to, 1) }, this.skipped.length) {
        $ = [];
        for (let h of this.skipped) {
          let c = t.mapPos(h.from, 1), a = t.mapPos(h.to, -1);
          c < a && $.push({ from: c, to: a });
        }
      }
    }
    return new Ut(this.parser, e, s, r, i, n, $, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(t) {
    if (this.viewport.from == t.from && this.viewport.to == t.to)
      return !1;
    this.viewport = t;
    let e = this.skipped.length;
    for (let s = 0; s < this.skipped.length; s++) {
      let { from: r, to: i } = this.skipped[s];
      r < t.to && i > t.from && (this.fragments = ze(this.fragments, r, i), this.skipped.splice(s--, 1));
    }
    return this.skipped.length >= e ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(t, e) {
    this.skipped.push({ from: t, to: e });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(t) {
    return new class extends Qe {
      createParse(e, s, r) {
        let i = r[0].from, n = r[r.length - 1].to;
        return {
          parsedPos: i,
          advance() {
            let l = Vt;
            if (l) {
              for (let h of r)
                l.tempSkipped.push(h);
              t && (l.scheduleOn = l.scheduleOn ? Promise.all([l.scheduleOn, t]) : t);
            }
            return this.parsedPos = n, new k(R.none, [], [], n - i);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(t) {
    t = Math.min(t, this.state.doc.length);
    let e = this.fragments;
    return this.treeLen >= t && e.length && e[0].from == 0 && e[0].to >= t;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return Vt;
  }
}
function ze(o, t, e) {
  return ot.applyChanges(o, [{ fromA: t, toA: e, fromB: t, toB: e }]);
}
class ft {
  constructor(t) {
    this.context = t, this.tree = t.tree;
  }
  apply(t) {
    if (!t.docChanged && this.tree == this.context.tree)
      return this;
    let e = this.context.changes(t.changes, t.state), s = this.context.treeLen == t.startState.doc.length ? void 0 : Math.max(t.changes.mapPos(this.context.treeLen), e.viewport.to);
    return e.work(20, s) || e.takeTree(), new ft(e);
  }
  static init(t) {
    let e = Math.min(3e3, t.doc.length), s = Ut.create(t.facet(pt).parser, t, { from: 0, to: e });
    return s.work(20, e) || s.takeTree(), new ft(s);
  }
}
_.state = /* @__PURE__ */ Ae.define({
  create: ft.init,
  update(o, t) {
    for (let e of t.effects)
      if (e.is(_.setState))
        return e.value;
    return t.startState.facet(pt) != t.state.facet(pt) ? ft.init(t.state) : o.apply(t);
  }
});
let es = (o) => {
  let t = setTimeout(
    () => o(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(t);
};
typeof requestIdleCallback < "u" && (es = (o) => {
  let t = -1, e = setTimeout(
    () => {
      t = requestIdleCallback(o, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => t < 0 ? clearTimeout(e) : cancelIdleCallback(t);
});
const Qt = typeof navigator < "u" && (!((Nt = navigator.scheduling) === null || Nt === void 0) && Nt.isInputPending) ? () => navigator.scheduling.isInputPending() : null, Zs = /* @__PURE__ */ Dt.fromClass(class {
  constructor(t) {
    this.view = t, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(t) {
    let e = this.view.state.field(_.state).context;
    (e.updateViewport(t.view.viewport) || this.view.viewport.to > e.treeLen) && this.scheduleWork(), (t.docChanged || t.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(e);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: t } = this.view, e = t.field(_.state);
    (e.tree != e.context.tree || !e.context.isDone(t.doc.length)) && (this.working = es(this.work));
  }
  work(t) {
    this.working = null;
    let e = Date.now();
    if (this.chunkEnd < e && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = e + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: s, viewport: { to: r } } = this.view, i = s.field(_.state);
    if (i.tree == i.context.tree && i.context.isDone(
      r + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let n = Date.now() + Math.min(this.chunkBudget, 100, t && !Qt ? Math.max(25, t.timeRemaining() - 5) : 1e9), $ = i.context.treeLen < r && s.doc.length > r + 1e3, l = i.context.work(() => Qt && Qt() || Date.now() > n, r + ($ ? 0 : 1e5));
    this.chunkBudget -= Date.now() - e, (l || this.chunkBudget <= 0) && (i.context.takeTree(), this.view.dispatch({ effects: _.setState.of(new ft(i.context)) })), this.chunkBudget > 0 && !(l && !$) && this.scheduleWork(), this.checkAsyncSchedule(i.context);
  }
  checkAsyncSchedule(t) {
    t.scheduleOn && (this.workScheduled++, t.scheduleOn.then(() => this.scheduleWork()).catch((e) => os(this.view.state, e)).then(() => this.workScheduled--), t.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), pt = /* @__PURE__ */ _t.define({
  combine(o) {
    return o.length ? o[0] : null;
  },
  enables: (o) => [
    _.state,
    Zs,
    nt.contentAttributes.compute([o], (t) => {
      let e = t.facet(o);
      return e && e.name ? { "data-language": e.name } : {};
    })
  ]
});
class Ms {
  /**
  Create a language support object.
  */
  constructor(t, e = []) {
    this.language = t, this.support = e, this.extension = [t, e];
  }
}
class Kt {
  constructor(t, e) {
    this.specs = t;
    let s;
    function r($) {
      let l = Be.newName();
      return (s || (s = /* @__PURE__ */ Object.create(null)))["." + l] = $, l;
    }
    const i = typeof e.all == "string" ? e.all : e.all ? r(e.all) : void 0, n = e.scope;
    this.scope = n instanceof _ ? ($) => $.prop(ct) == n.data : n ? ($) => $ == n : void 0, this.style = ts(t.map(($) => ({
      tag: $.tag,
      class: $.class || r(Object.assign({}, $, { tag: null }))
    })), {
      all: i
    }).style, this.module = s ? new Be(s) : null, this.themeType = e.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(t, e) {
    return new Kt(t, e || {});
  }
}
const oe = /* @__PURE__ */ _t.define(), ss = /* @__PURE__ */ _t.define({
  combine(o) {
    return o.length ? [o[0]] : null;
  }
});
function Zt(o) {
  let t = o.facet(oe);
  return t.length ? t : o.facet(ss);
}
function Ls(o, t) {
  let e = [tr], s;
  return o instanceof Kt && (o.module && e.push(nt.styleModule.of(o.module)), s = o.themeType), t != null && t.fallback ? e.push(ss.of(o)) : s ? e.push(oe.computeN([nt.darkTheme], (r) => r.facet(nt.darkTheme) == (s == "dark") ? [o] : [])) : e.push(oe.of(o)), e;
}
class Hs {
  constructor(t) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = Z(t.state), this.decorations = this.buildDeco(t, Zt(t.state));
  }
  update(t) {
    let e = Z(t.state), s = Zt(t.state), r = s != Zt(t.startState);
    e.length < t.view.viewport.to && !r && e.type == this.tree.type ? this.decorations = this.decorations.map(t.changes) : (e != this.tree || t.viewportChanged || r) && (this.tree = e, this.decorations = this.buildDeco(t.view, s));
  }
  buildDeco(t, e) {
    if (!e || !this.tree.length)
      return G.none;
    let s = new le();
    for (let { from: r, to: i } of t.visibleRanges)
      As(this.tree, e, (n, $, l) => {
        s.add(n, $, this.markCache[l] || (this.markCache[l] = G.mark({ class: l })));
      }, r, i);
    return s.finish();
  }
}
const tr = /* @__PURE__ */ je.high(/* @__PURE__ */ Dt.fromClass(Hs, {
  decorations: (o) => o.decorations
})), er = /* @__PURE__ */ Object.create(null), ve = [R.none], Ue = [], De = /* @__PURE__ */ Object.create(null), sr = /* @__PURE__ */ Object.create(null);
for (let [o, t] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  sr[o] = /* @__PURE__ */ rr(er, t);
function Mt(o, t) {
  Ue.indexOf(o) > -1 || (Ue.push(o), console.warn(t));
}
function rr(o, t) {
  let e = [];
  for (let $ of t.split(" ")) {
    let l = [];
    for (let h of $.split(".")) {
      let c = o[h] || d[h];
      c ? typeof c == "function" ? l.length ? l = l.map(c) : Mt(h, `Modifier ${h} used at start of tag`) : l.length ? Mt(h, `Tag ${h} used as modifier`) : l = Array.isArray(c) ? c : [c] : Mt(h, `Unknown highlighting tag ${h}`);
    }
    for (let h of l)
      e.push(h);
  }
  if (!e.length)
    return 0;
  let s = t.replace(/ /g, "_"), r = s + " " + e.map(($) => $.id), i = De[r];
  if (i)
    return i.id;
  let n = De[r] = R.define({
    id: ve.length,
    name: s,
    props: [Le({ [s]: e })]
  });
  return ve.push(n), n.id;
}
kt.RTL, kt.LTR;
const ir = vt.define({
  name: "icu-tolgee",
  parser: Yt.configure({
    props: [
      Le({
        TextRoot: d.string,
        Text: d.string,
        PluralPlaceholder: d.keyword,
        VariantDescriptor: d.keyword,
        FormatFunction: d.keyword,
        SelectFunction: d.keyword,
        Param: d.variableName,
        FormatStyle: d.variableName,
        "{ }": d.paren,
        Sep: d.separator,
        "< >": d.tagName,
        Slash: d.tagName,
        TagName: d.tagName
      })
    ]
  })
});
function Sr() {
  return new Ms(ir);
}
const br = (o) => Ls(
  Kt.define([
    { tag: d.variableName, color: o.other },
    { tag: d.keyword, color: o.function },
    { tag: d.bracket, color: o.other },
    { tag: d.tagName, color: o.other },
    { tag: d.content, color: o.main },
    { tag: d.string, color: o.main }
  ])
), Ir = Dt.fromClass(
  class {
    constructor(o) {
      mt(this, "isolates");
      mt(this, "tree");
      this.isolates = _e(o), this.tree = Z(o.state);
    }
    update(o) {
      (o.docChanged || o.viewportChanged || Z(o.state) != this.tree) && (this.isolates = _e(o.view), this.tree = Z(o.state));
    }
  },
  {
    provide: (o) => {
      function t(e) {
        var s;
        return ((s = e.plugin(o)) == null ? void 0 : s.isolates) ?? G.none;
      }
      return je.lowest([
        nt.decorations.of(t),
        nt.bidiIsolatedRanges.of(t)
      ]);
    }
  }
), nr = G.mark({
  attributes: { style: "direction: ltr; unicode-bidi: isolate" },
  bidiIsolate: kt.LTR
}), or = G.mark({
  attributes: { style: "direction: rtl; unicode-bidi: isolate" },
  bidiIsolate: kt.RTL
});
function _e(o) {
  const t = new le();
  for (const { from: e, to: s } of o.visibleRanges)
    Z(o.state).iterate({
      from: e,
      to: s,
      enter(r) {
        (r.name === "HtmlTagOpen" || r.name === "HtmlTagClose" || r.name === "Expression") && t.add(r.from, r.to, nr), (r.name === "TextRoot" || r.name === "Text") && t.add(r.from, r.to, or);
      }
    });
  return t.finish();
}
const $r = {
  variable: {
    border: "#7AD3C1",
    background: "#BEF3E9",
    text: "#008371"
  },
  tag: {
    border: "#F27FA6",
    background: "#F9C4D6",
    text: "#822343"
  },
  variant: {
    border: "#BBC2CB",
    background: "#F0F2F4",
    text: "#4D5B6E"
  }
}, Pr = ({
  styled: o,
  colors: t = $r,
  component: e = "div"
}) => o(e)`
    white-space: pre-wrap;
    & .placeholder-widget {
      display: inline-flex;
      vertical-align: text-top;
      align-items: center;
      justify-content: center;
      min-width: 15px;
      border: 1px solid ${t.variable.border};
      background-color: ${t.variable.background};
      color: ${t.variable.text};
      border-radius: 10px;
      padding: 0px 7px;
      font-size: 12px;
      user-select: none;
      margin: 0px 1px;
      overflow: hidden;

      & > * {
        display: grid;
      }
    }
    & .placeholder-error {
      background: #ff000054;
    }

    & .placeholder-tagOpen {
      border: 1px solid ${t.tag.border};
      background-color: ${t.tag.background};
      color: ${t.tag.text};
      border-radius: 10px 0px 0px 10px;
      padding-right: 6px;
    }

    & .placeholder-tagClose {
      border: 1px solid ${t.tag.border};
      background-color: ${t.tag.background};
      color: ${t.tag.text};
      border-radius: 0px 10px 10px 0px;
      padding-left: 6px;
    }

    // in rtl mode, revert the placeholders direction
    &[dir="rtl"] .placeholder-tagOpen {
      border-radius: 0px 10px 10px 0px;
      padding-left: 6px;
    }
    &[dir="rtl"] .placeholder-tagClose {
      border-radius: 10px 0px 0px 10px;
      padding-right: 6px;
    }
  `, lr = (o) => /^[^\p{White_Space}\p{Pattern_Syntax}]*$/uy.test(o), wt = 0, Lt = 1, Ht = 2, te = 3, $e = /* @__PURE__ */ new Set(["{"]), Ye = /* @__PURE__ */ new Set([...$e, "}"]), ht = "'", hr = (o) => {
  let t = wt;
  const e = [];
  let s;
  for (const r of o)
    switch (t) {
      case wt:
        r === ht ? t = Ht : $e.has(r) && (e.push(ht), s = e.length, t = te), e.push(r);
        break;
      case Ht:
        $e.has(r) ? (s = e.length, t = Lt) : t = wt, e.push(r);
        break;
      case Lt:
        r === ht ? t = wt : Ye.has(r) && (s = e.length), e.push(r);
        break;
      case te:
        r === ht ? (e.splice(s + 1, 0, ht), t = Ht) : Ye.has(r) && (s = e.length), e.push(r);
        break;
    }
  return [Lt, te].includes(t) && e.splice(s + 1, 0, ht), e.join("");
};
function ar(o) {
  return Yt.configure({ strict: !0 }).parse(o);
}
const wr = (o) => {
  const { parameter: t, variants: e } = o;
  if (!t)
    return e.other ?? "";
  if (!lr(t))
    throw new Error(`Parameter name "${t}" is invalid`);
  const s = [`{${t}, plural,`];
  e.other || (e.other = "");
  let r = !0;
  for (const [i, n] of Object.entries(e)) {
    r && n && (r = !1);
    try {
      ar(`{${t}, plural, other {${n}}}`), s.push(` ${i} {${n}}`);
    } catch {
      s.push(` ${i} {${hr(n || "")}}`);
    }
  }
  return r ? "" : (s.push("}"), s.join(""));
}, Ke = {
  0: fe,
  4: pe,
  6: Ze,
  // this also excludes 'offset:x'
  8: Me
};
function Et(o, t) {
  return t.substring(o.from, o.to);
}
function cr(o, t) {
  let e = o.firstChild;
  do
    if ((e == null ? void 0 : e.type.id) === Js)
      return Et(e, t);
  while (e = e == null ? void 0 : e.nextSibling);
  return "";
}
function Wt(o) {
  return { variants: { other: o } };
}
const ur = (o) => {
  let t;
  try {
    t = Yt.configure({ strict: !0 }).parse(o);
  } catch {
    return Wt(o);
  }
  const e = t.cursor(), s = {}, r = {}, i = Object.keys(Ke), n = Number(i[i.length - 1]);
  for (let l = 0; l <= n; l++) {
    e.next();
    const h = e.node, c = Ke[l];
    if (c !== void 0)
      if (c === h.type.id)
        s[h.type.id] = h;
      else
        return Wt(o);
  }
  if (s[fe].nextSibling || Et(s[Ze], o) !== "plural")
    return Wt(o);
  let $ = s[Me];
  do {
    const l = Et($.firstChild, o), h = cr($, o);
    if (r[l] !== void 0)
      return Wt(o);
    r[l] = h;
  } while ($ = $.nextSibling);
  return {
    parameter: Et(s[pe], o),
    variants: r
  };
}, Jr = (o, t) => t ? ur(o || "") : { variants: { other: o } }, fr = [6, 7, 8, 11, 20, 21, 1e6, 0.5, 0.1, 0], pr = [0, 2, 3, 4, 6], dr = [10, 11, 20, 100, 0, 0, 0.1, 2, 3, 4], Vr = [
  "zero",
  "one",
  "two",
  "few",
  "many",
  "other"
], yr = (o) => {
  const t = new Set(
    new Intl.PluralRules(o).resolvedOptions().pluralCategories
  );
  return Vr.filter((e) => t.has(e));
}, at = (o, t, e) => {
  const s = new Intl.PluralRules(t);
  return e.find((r) => s.select(r) === o);
}, Er = (o, t) => {
  switch (t) {
    case "zero":
      return at("zero", o, [0]);
    case "one":
      return at("one", o, [1]);
    case "two":
      return at("two", o, [2]);
    case "few":
      return at("few", o, pr);
    case "many":
      return at("many", o, fr);
    case "other":
      return at("other", o, dr);
  }
}, kr = (o) => {
  const t = [
    "ar",
    "arc",
    "dv",
    "fa",
    "ha",
    "he",
    "khw",
    "ks",
    "ku",
    "ps",
    "ur",
    "yi"
  ], e = o.replace(/^([a-zA-Z]+)(.*?)$/, "$1");
  return t.indexOf(e) > -1 ? "rtl" : "ltr";
};
export {
  mr as PlaceholderPlugin,
  br as TolgeeHighlight,
  lr as checkParamNameIsValid,
  Pr as generatePlaceholdersStyle,
  kr as getLanguageDirection,
  Ts as getPlaceholders,
  yr as getPluralVariants,
  Jr as getTolgeeFormat,
  Er as getVariantExample,
  Ir as htmlIsolatesPlugin,
  wr as tolgeeFormatGenerateIcu,
  Yt as tolgeeParser,
  Sr as tolgeeSyntax
};
